Package: fobitools
Title: Tools for Manipulating the FOBI Ontology
Version: 1.20.0
Authors@R: 
    c(person(given = "Pol",
             family = "Castellano-Escuder",
             role = c("aut", "cre"),
             email = "polcaes@gmail.com",
             comment = c(ORCID = "0000-0001-6466-877X")),
      person(given = "Alex",
             family = "Sánchez-Pla",
             role = "aut",
             email = "asanchez@ub.edu",
             comment = c(ORCID = "0000-0002-8673-7737"))
             )
Description: A set of tools for interacting with the Food-Biomarker Ontology (FOBI). A collection 
    of basic manipulation tools for biological significance analysis, graphs, and text mining 
    strategies for annotating nutritional data.
License: GPL-3
Encoding: UTF-8
LazyData: true
biocViews: MassSpectrometry, Metabolomics, Software, Visualization,
        BiomedicalInformatics, GraphAndNetwork, Annotation,
        Cheminformatics, Pathways, GeneSetEnrichment
Imports: clisymbols, crayon, dplyr, fgsea, ggplot2, ggraph, magrittr,
        ontologyIndex, purrr, RecordLinkage, stringr, textclean,
        tictoc, tidygraph, tidyr, vroom
Suggests: BiocStyle, covr, ggrepel, kableExtra, knitr,
        metabolomicsWorkbenchR, POMA, rmarkdown, rvest,
        SummarizedExperiment, testthat (>= 2.3.2), tidyverse
RoxygenNote: 7.3.2
Depends: R (>= 4.1)
URL: https://github.com/pcastellanoescuder/fobitools/
BugReports: https://github.com/pcastellanoescuder/fobitools/issues
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/fobitools
git_branch: RELEASE_3_23
git_last_commit: 7bd39a6
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:09:02 UTC; biocbuild
Author: Pol Castellano-Escuder [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-6466-877X>),
  Alex Sánchez-Pla [aut] (ORCID: <https://orcid.org/0000-0002-8673-7737>)
Maintainer: Pol Castellano-Escuder <polcaes@gmail.com>

# `fobitools` <img src='man/figures/logo.png' align="right" height="139" />

<!-- badges: start -->

[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://www.tidyverse.org/lifecycle/#stable)
[![Actions
Status](https://github.com/pcastellanoescuder/fobitools/workflows/R-CMD-check/badge.svg)](https://github.com/pcastellanoescuder/fobitools/actions)
[![Bioc release
status](https://bioconductor.org/shields/build/release/bioc/fobitools.svg)](https://bioconductor.org/checkResults/release/bioc-LATEST/fobitools/)
[![Bioc devel
status](https://bioconductor.org/shields/build/devel/bioc/fobitools.svg)](https://bioconductor.org/checkResults/devel/bioc-LATEST/fobitools/)
[![Last
Commit](https://img.shields.io/github/last-commit/pcastellanoescuder/fobitools.svg)](https://github.com/pcastellanoescuder/fobitools/commits/main)
[![License: GPL
v3](https://img.shields.io/badge/License-GPLv3-blue.svg)](https://www.gnu.org/licenses/gpl-3.0)
[![DOI](https://img.shields.io/badge/DOI-https%3A%2F%2Fdoi.org%2F10.1093%2Fdataba%2Fbaaa033-blue)](https://doi.org/10.1093/databa/baaa033)

<!-- badges: end -->

This package provides a set of tools for interacting with [FOBI
(Food-Biomarker
Ontology)](https://github.com/pcastellanoescuder/FoodBiomarkerOntology).
A collection of basic manipulation tools for biological significance
analysis, graph visualization and text mining strategies for annotating
nutritional data are provided here:

- Graph visualization of FOBI
- Parse FOBI information from OBO to a readable table format
- Compound ID conversion (among metabolite names, FOBI, ChemSpider,
  KEGG, PubChemCID, InChIKey, InChICode and HMDB IDs)
- Biological significance analysis via ORA and MSEA methods:
  - Chemical class enrichment analysis: ORA and MSEA using FOBI chemical
    classes as metabolite sets
  - Food enrichment analysis: ORA and MSEA using FOBI food groups as
    metabolite sets
- Text mining algorithm for annotating free-text dietary data

`fobitools` also offers a Shiny app version called
[fobitoolsGUI](https://github.com/pcastellanoescuder/fobitoolsGUI). This
application implements most of `fobitools` functions in an user-friendly
web interface and it is available at
<http://webapps.nutrimetabolomics.com/fobitoolsGUI>.

# Installation

To install Bioconductor version use:

``` r
# install.packages("BiocManager")
BiocManager::install("fobitools")
```

If you need the GitHub version (not recommended unless you know what you
are doing), use:

``` r
# install.packages("devtools")
devtools::install_github("pcastellanoescuder/fobitools")
```

## Citation

**Pol Castellano-Escuder, Raúl González-Domínguez, David S Wishart,
Cristina Andrés-Lacueva, Alex Sánchez-Pla**, *FOBI: an ontology to
represent food intake data and associate it with metabolomic data*,
Database, Volume 2020, 2020, baaa033. DOI:
<https://doi.org/10.1093/databa/baaa033>

# Code of Conduct

Please note that the ‘fobitools’ project is released with a [Contributor
Code of Conduct](CODE_OF_CONDUCT.md). By contributing to this project,
you agree to abide by its terms.

#' Convert Metabolite Identifiers
#'
#' @description This function can convert metabolite identifiers to other available IDs in FOBI. Input vector can be a combination of different IDs. 
#'
#' @param ids A vector with metabolite IDs to convert. Input ID types can be FOBI, raw metabolite names (used in FOBI), HMDB, KEGG, PubChemCID, InChIKey, InChICode, ChemSpider, and a combination of them.
#' @param to Target ID type. If possible, metabolites will be converted to this ID type. Options are "FOBI" (default), "metaboliteNames", "HMDB", "KEGG", "PubChemCID", "InChIKey", "InChICode", and "ChemSpider".
#' @param fobi FOBI table obtained with `parse_fobi()`. If this value is set to NULL, the last version of FOBI will be downloaded from GitHub.
#' 
#' @export
#'
#' @return A tibble with input IDs and converted IDs.
#' @references Pol Castellano-Escuder, Raúl González-Domínguez, David S Wishart, Cristina Andrés-Lacueva, Alex Sánchez-Pla, FOBI: an ontology to represent food intake data and associate it with metabolomic data, Database, Volume 2020, 2020, baaa033, https://doi.org/10.1093/databa/baaa033.
#' @author Pol Castellano-Escuder
#'
#' @examples
#' 
#' ids <- c(fobitools::idmap$HMDB[1:10], 
#'          fobitools::idmap$KEGG[11:23], 
#'          fobitools::idmap$InChIKey[100:150])
#' fobitools::id_convert(ids, to = "FOBI")
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr mutate select rename filter mutate_all matches vars select_at filter_all any_vars as_tibble relocate last_col mutate_at
#' @importFrom stringr regex str_replace_all str_trim
id_convert <- function(ids,
                       to = "FOBI",
                       fobi = fobitools::fobi){
  
  if (!(to %in% c("FOBI", "PubChemCID", "KEGG", "InChIKey", "InChICode", "ChemSpider", "metaboliteNames", "HMDB"))) {
    stop("Select a valid ID type!")
  }
  
  if (is.null(fobi)){
    fobi <- parse_fobi()
  }
  
  idmap <- fobi %>%
    filter(!BiomarkerOf == "NULL") %>%
    select(name, FOBI, HMDB, KEGG, PubChemCID, InChIKey, InChICode, ChemSpider) %>%
    mutate_all(as.character) %>%
    mutate_at(c("HMDB", "KEGG", "PubChemCID", "ChemSpider"), ~ str_replace_all(., regex("( ).*"), regex("\\1"))) %>%
    rename(metaboliteNames = name) %>%
    mutate_all(~ ifelse(. == "NULL", NA, .)) %>%
    mutate_all(~ stringr::str_trim(.)) %>%
    filter(!duplicated(metaboliteNames))

  ids <- ids[!is.na(ids)]
  from <- data.frame(presence = apply(idmap, 2, function(x) any(ids %in% x))) %>%
    filter(presence == "TRUE")
    
  conversion <- idmap %>%
    select_at(vars(dplyr::matches(rownames(from)), dplyr::matches(to))) %>%
    filter_all(any_vars(. %in% ids)) %>%
    relocate(last_col()) %>%
    as_tibble()
  
  return(conversion)
  
}

context("id_convert")

test_that("id_convert works", {
  
  ids <- c(fobitools::idmap$HMDB[1:10], fobitools::idmap$KEGG[11:23], fobitools::idmap$InChIKey[100:150])
  nas <- sum(is.na(ids))
    
  ##
    
  a <- fobitools::id_convert(ids, to = "FOBI")
  b <- fobitools::id_convert(ids, to = "PubChemCID", fobi = NULL)
  
  ##
  
  expect_equal(ncol(a), 4)
  expect_equal(ncol(b), 4)
  
  ##
  
  expect_true(class(a)[2] == "tbl")
  expect_true(class(b)[2] == "tbl")
  
  ##
  
  expect_equal(nrow(a), length(ids) - nas)
  expect_equal(nrow(b), length(ids) - nas)
  
  ##
  
  expect_error(fobitools::id_convert(ids, to = "FOB"))
  
})

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----eval = FALSE-------------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("fobitools")

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
library(fobitools)

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
library(tidyverse)
library(kableExtra)

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
load("data/sample_ffq.rda")

sample_ffq %>%
  dplyr::slice(1L:10L) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))

## ----warning = FALSE----------------------------------------------------------
annotated_text <- fobitools::annotate_foods(sample_ffq)

annotated_text$annotated %>%
  dplyr::slice(1L:10L) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))

## ----warning = FALSE----------------------------------------------------------
annotated_text_95 <- fobitools::annotate_foods(sample_ffq, similarity = 0.95)

annotated_text_95$annotated %>%
  dplyr::slice(1L:10L) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))

## ----warning = FALSE----------------------------------------------------------
annotated_text$annotated %>%
  filter(!FOOD_ID %in% annotated_text_95$annotated$FOOD_ID) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))

## ----warning = FALSE, message = FALSE, comment = FALSE, fig.width = 12, fig.height = 10----
terms <- annotated_text$annotated %>%
  pull(FOBI_ID)

fobitools::fobi_graph(terms = terms,
                      get = NULL,
                      layout = "lgl",
                      labels = TRUE,
                      legend = TRUE,
                      labelsize = 6,
                      legendSize = 20)

## ----warning = FALSE----------------------------------------------------------
inverse_rel <- fobitools::fobi %>%
  filter(id_BiomarkerOf %in% annotated_text$annotated$FOBI_ID) %>%
  dplyr::select(id_code, name, id_BiomarkerOf, FOBI) %>%
  dplyr::rename(METABOLITE_ID = 1, METABOLITE_NAME = 2, FOBI_ID = 3, METABOLITE_FOBI_ID = 4)

annotated_foods_and_metabolites <- left_join(annotated_text$annotated, inverse_rel, by = "FOBI_ID")

annotated_foods_and_metabolites %>%
  filter(!is.na(METABOLITE_ID)) %>%
  dplyr::slice(1L:10L) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))

## -----------------------------------------------------------------------------
sessionInfo()

#' Classical Over Representation Analysis with FOBI
#'
#' @description This function performs a traditional over representation analysis based on hypergeometric test: classes are treated as sets of individual metabolites and all metabolites are treated as equally informative. This function uses Food-Biomarker Ontology knowledge as biological information.
#'
#' @param metaboliteList A vector of FOBI metabolite identifiers that define the selected list of metabolites.
#' @param metaboliteUniverse A vector of FOBI metabolite identifiers that define the universe of possible metabolites (all metabolites analyzed in the study).
#' @param subOntology A character string specifying one of the two FOBI sub-ontologies: "food", or "biomarker".
#' @param pvalCutoff A numeric value indicating a p-value cutoff for raw p-values generated by hypergeometric test.
#' @param fobi FOBI table obtained with `parse_fobi()`. If this value is set to NULL, the last version of FOBI will be downloaded from GitHub.
#'
#' @export
#'
#' @return A tibble with ORA results.
#' @references G. Korotkevich, V. Sukhov, A. Sergushichev. Fast gene set enrichment analysis. bioRxiv (2019), doi:10.1101/060012
#' @references Pol Castellano-Escuder, Raúl González-Domínguez, David S Wishart, Cristina Andrés-Lacueva, Alex Sánchez-Pla, FOBI: an ontology to represent food intake data and associate it with metabolomic data, Database, Volume 2020, 2020, baaa033, https://doi.org/10.1093/databa/baaa033.
#' @author Pol Castellano-Escuder
#'
#' @examples
#' 
#' metaboliteUniverse <- c(fobitools::idmap$FOBI[1:200], fobitools::idmap$FOBI[400:450])
#' metaboliteList <- c(fobitools::idmap$FOBI[1:50], fobitools::idmap$FOBI[70:80])
#' 
#' # Food enrichment analysis
#' fobitools::ora(metaboliteList = metaboliteList, 
#'                metaboliteUniverse = metaboliteUniverse, 
#'                pvalCutoff = 1)
#' 
#' # Chemical class enrichment analysis
#' fobitools::ora(metaboliteList = metaboliteList, 
#'                metaboliteUniverse = metaboliteUniverse, 
#'                subOntology = "biomarker", 
#'                pvalCutoff = 1)
#' 
#' @importFrom magrittr %>%
#' @importFrom tidyr unnest
#' @importFrom dplyr select rename filter mutate_all arrange desc as_tibble
#' @importFrom fgsea fora
ora <- function(metaboliteList,
                metaboliteUniverse,
                subOntology = "food",
                pvalCutoff = 0.01,
                fobi = fobitools::fobi){

  if (is.null(metaboliteList)) {
    stop("metaboliteList must be a vector with selected metabolites")
  }
  if (!is.vector(metaboliteList)) {
    stop("metaboliteList must be a vector with selected metabolites")
  }
  if (is.null(metaboliteUniverse)) {
    stop("metaboliteUniverse must be a vector with the universe of possible metabolites")
  }
  if (!is.vector(metaboliteUniverse)) {
    stop("metaboliteUniverse must be a vector with the universe of possible metabolites")
  }
  if (!(subOntology %in% c("food", "biomarker"))) {
    stop("Incorrect value for subOntology argument. Options are 'food' and 'biomarker'")
  }
  if (pvalCutoff < 0) {
    stop("pvalCutoff cannot be less than zero")
  }

  ##

  if (is.null(fobi)){
    fobi <- parse_fobi()
  }
  
  ##
  
  n_metaboliteUniverse <- length(unique(metaboliteUniverse[!is.na(metaboliteUniverse)]))
  metaboliteUniverse <- unique(metaboliteUniverse[!is.na(metaboliteUniverse)])
    
  ##

  ptw_foods <- fobi %>%
    dplyr::filter(!BiomarkerOf == "NULL") %>%
    dplyr::select(id_BiomarkerOf, BiomarkerOf, name, FOBI) %>%
    tidyr::unnest(cols = c(id_BiomarkerOf, BiomarkerOf, name, FOBI)) %>%
    dplyr::mutate_all(as.factor)
  
  ptw_chemicals <- fobi %>%
    dplyr::filter(!BiomarkerOf == "NULL") %>%
    dplyr::select(is_a_code, is_a_name, name, FOBI) %>%
    tidyr::unnest(cols = c(is_a_code, is_a_name, name, FOBI)) %>%
    dplyr::mutate_all(as.factor) %>%
    dplyr::filter(!duplicated(.))

  ##

  n_food_metabolites <- ptw_foods %>%
    dplyr::filter(FOBI %in% metaboliteUniverse) %>%
    dplyr::filter(duplicated(id_BiomarkerOf))
  
  n_biomarker_metabolites <- ptw_chemicals %>%
    dplyr::filter(FOBI %in% metaboliteUniverse) %>%
    dplyr::filter(duplicated(is_a_code)) 

  ##
  
  if (subOntology == "food") {
    if(nrow(n_food_metabolites) > 1){
      ptw <- unstack(ptw_foods[, c(4,2)])
    }
    else {
      stop("At least two FOBI food classes must be represented by more than one compound in the metaboliteUniverse!")
    }
  }
  
  else if (subOntology == "biomarker") {
    if(nrow(n_biomarker_metabolites) > 1){
      ptw <- unstack(ptw_chemicals[, c(4,2)])
    }
    else {
      stop("At least two FOBI chemical classes must be represented by more than one compound in the metaboliteUniverse!")
    }
  }
  
  ##

  metaboliteList <- unique(metaboliteList[!is.na(metaboliteList)])
  n_metaboliteList <- length(metaboliteList)
  
  ## ORA
  
  res_ora <- fgsea::fora(pathways = ptw, genes = metaboliteList, universe = metaboliteUniverse, minSize = 1, maxSize = Inf)
  
  result <- res_ora %>%
    dplyr::rename(className = pathway, classSize = size, overlapMetabolites = overlapGenes) %>%
    dplyr::select(className, classSize, overlap, pval, padj, overlapMetabolites) %>%
    dplyr::arrange(-dplyr::desc(pval)) %>%
    dplyr::filter(pval <= pvalCutoff) %>%
    dplyr::as_tibble()

  message(paste0(crayon::blue("metaboliteUniverse size: ", n_metaboliteUniverse), 
                 "\n",
                 crayon::blue("metaboliteList size: ", n_metaboliteList)))
  
  return(result)
  
}

context("ora")

test_that("ora works", {

  metaboliteUniverse <- c(fobitools::idmap$FOBI[1:200], fobitools::idmap$FOBI[400:450])
  metaboliteList <- c(fobitools::idmap$FOBI[1:50], fobitools::idmap$FOBI[70:80])

  data <- data.frame(A = metaboliteList[1:50], B = metaboliteList[51:100])

  a <- fobitools::ora(metaboliteList = metaboliteList, metaboliteUniverse = metaboliteUniverse, pvalCutoff = 1)
  b <- fobitools::ora(metaboliteList = metaboliteList, metaboliteUniverse = metaboliteUniverse, subOntology = "food", pvalCutoff = 1, fobi = NULL)
  c <- fobitools::ora(metaboliteList = metaboliteList, metaboliteUniverse = metaboliteUniverse, subOntology = "biomarker", pvalCutoff = 1)
  
  ##
  
  expect_true(class(a)[2] == "tbl")
  expect_true(class(b)[2] == "tbl")
  expect_true(class(c)[2] == "tbl")
  
  ##
  
  expect_equal(dim(a), dim(b))
  expect_equal(ncol(b), ncol(c))
  expect_equal(a$pvalue, b$pvalue)
  
  ##

  expect_error(fobitools::ora(metaboliteList, metaboliteUniverse = metaboliteUniverse, subOntology = "bio", pvalCutoff = 1))
  expect_error(fobitools::ora())
  expect_error(fobitools::ora(data))

})

#' Performs a preranked metabolite set enrichment analysis (MSEA)
#'
#' @description This function performs a MSEA based on the adaptive multilevel splitting Monte Carlo approach. 
#'
#' @param metaboliteRanks A named vector of FOBI metabolite identifiers with their metabolite-level stats.
#' @param subOntology A character string specifying one of the two FOBI sub-ontologies: "food", or "biomarker".
#' @param pvalCutoff A numeric value indicating a p-value cutoff for raw p-values generated by MSEA.
#' @param fobi FOBI table obtained with `parse_fobi()`. If this value is set to NULL, the last version of FOBI will be downloaded from GitHub.
#'
#' @export
#'
#' @return A tibble with MSEA results.
#' @references G. Korotkevich, V. Sukhov, A. Sergushichev. Fast gene set enrichment analysis. bioRxiv (2019), doi:10.1101/060012
#' @references Pol Castellano-Escuder, Raúl González-Domínguez, David S Wishart, Cristina Andrés-Lacueva, Alex Sánchez-Pla, FOBI: an ontology to represent food intake data and associate it with metabolomic data, Database, Volume 2020, 2020, baaa033, https://doi.org/10.1093/databa/baaa033.
#' @author Pol Castellano-Escuder
#'
#' @examples
#' 
#' metabolites <- c(fobitools::idmap$FOBI[1:49], fobitools::idmap$FOBI[70:80])
#' random_pvals <- c(runif(n = length(metabolites)*0.3, min = 0.001, max = 0.05), runif(n = length(metabolites)*0.7, min = 0.05, max = 0.99))
#' names(random_pvals) <- metabolites
#' metaboliteRanks <- random_pvals[order(random_pvals)]
#' 
#' # Food enrichment analysis
#' fobitools::msea(metaboliteRanks = metaboliteRanks, 
#'                 pvalCutoff = 1)
#' 
#' # Chemical class enrichment analysis
#' fobitools::msea(metaboliteRanks = metaboliteRanks, 
#'                 subOntology = "biomarker", 
#'                 pvalCutoff = 1)
#' 
#' @importFrom magrittr %>%
#' @importFrom tidyr unnest
#' @importFrom dplyr select rename filter mutate_all arrange desc as_tibble
#' @importFrom fgsea fgsea
msea <- function(metaboliteRanks,
                 subOntology = "food",
                 pvalCutoff = 0.01,
                 fobi = fobitools::fobi){
  
  if (is.null(metaboliteRanks)) {
    stop("metaboliteRanks must be a named vector with ranked metabolites")
  }
  if (!is.vector(metaboliteRanks)) {
    stop("metaboliteRanks must be a named vector with ranked metabolites")
  }
  if (is.null(names(metaboliteRanks))) {
    stop("metaboliteRanks must be a named vector with ranked metabolites")
  }
  if (!(subOntology %in% c("food", "biomarker"))) {
    stop("Incorrect value for subOntology argument. Options are 'food' and 'biomarker'")
  }
  if (pvalCutoff < 0) {
    stop("pvalCutoff cannot be less than zero")
  }
  
  ##
  
  if (is.null(fobi)){
    fobi <- parse_fobi()
  }
  
  ##
  
  ptw_foods <- fobi %>%
    dplyr::filter(!BiomarkerOf == "NULL") %>%
    dplyr::select(id_BiomarkerOf, BiomarkerOf, name, FOBI) %>%
    tidyr::unnest(cols = c(id_BiomarkerOf, BiomarkerOf, name, FOBI)) %>%
    dplyr::mutate_all(as.factor)
  
  ptw_chemicals <- fobi %>%
    dplyr::filter(!BiomarkerOf == "NULL") %>%
    dplyr::select(is_a_code, is_a_name, name, FOBI) %>%
    tidyr::unnest(cols = c(is_a_code, is_a_name, name, FOBI)) %>%
    dplyr::mutate_all(as.factor) %>%
    dplyr::filter(!duplicated(.))
  
  ##
  
  n_food_metabolites <- ptw_foods %>%
    dplyr::filter(FOBI %in% names(metaboliteRanks)) %>%
    dplyr::filter(duplicated(id_BiomarkerOf))
  
  n_biomarker_metabolites <- ptw_chemicals %>%
    dplyr::filter(FOBI %in% names(metaboliteRanks)) %>%
    dplyr::filter(duplicated(is_a_code)) 
  
  ##
  
  if (subOntology == "food") {
    if(nrow(n_food_metabolites) > 1){
      ptw <- unstack(ptw_foods[, c(4,2)])
    }
    else {
      stop("At least two FOBI food classes must be represented by more than one compound in the metaboliteRanks!")
    }
  }
  
  else if (subOntology == "biomarker") {
    if(nrow(n_biomarker_metabolites) > 1){
      ptw <- unstack(ptw_chemicals[, c(4,2)])
    }
    else {
      stop("At least two FOBI chemical classes must be represented by more than one compound in the metaboliteRanks!")
    }
  }
  
  ##
  
  ranks <- metaboliteRanks[!duplicated(metaboliteRanks)]
   
  ## MSEA
  
  scoreType <- "std"
  
  if(all(as.numeric(ranks) > 0)) {
    scoreType <- "pos"
  }
  else if(all(as.numeric(ranks) < 0)) {
    scoreType <- "neg"
  }
  
  res_msea <- fgsea::fgsea(pathways = ptw, stats = ranks, eps = 0, minSize = 1, maxSize = Inf, scoreType = scoreType)
  
  result <- res_msea %>%
    dplyr::rename(className = pathway, classSize = size) %>%
    dplyr::select(className, classSize, log2err, ES, NES, pval, padj, leadingEdge) %>%
    dplyr::arrange(-dplyr::desc(pval)) %>%
    dplyr::filter(pval <= pvalCutoff) %>%
    dplyr::as_tibble()
  
  return(result)
  
}

context("msea")

test_that("msea works", {
  
  metabolites <- c(fobitools::idmap$FOBI[1:49], fobitools::idmap$FOBI[70:80])
  random_pvals <- c(runif(n = length(metabolites)*0.3, min = 0.001, max = 0.05), runif(n = length(metabolites)*0.7, min = 0.05, max = 0.99))
  names(random_pvals) <- metabolites
  
  metaboliteRanks <- random_pvals[order(random_pvals)]
    
  data <- data.frame(A = metaboliteRanks[1:50], B = metaboliteRanks[51:100])
  
  a <- fobitools::msea(metaboliteRanks = metaboliteRanks, pvalCutoff = 1)
  b <- fobitools::msea(metaboliteRanks = metaboliteRanks, subOntology = "food", pvalCutoff = 1, fobi = NULL)
  c <- fobitools::msea(metaboliteRanks = metaboliteRanks, subOntology = "biomarker", pvalCutoff = 1)
  
  ##
  
  expect_true(class(a)[2] == "tbl")
  expect_true(class(b)[2] == "tbl")
  expect_true(class(c)[2] == "tbl")
  
  ##
  
  expect_equal(dim(a), dim(b))
  expect_equal(ncol(b), ncol(c))
  expect_equal(a$pvalue, b$pvalue)
  
  ##
  
  expect_error(fobitools::msea(metaboliteRanks, subOntology = "bio", pvalCutoff = 1))
  expect_error(fobitools::msea())
  expect_error(fobitools::msea(data))
  expect_error(fobitools::msea(metabolites))
  
})

#' Generate FOBI Graphs
#'
#' @description This function allows users to create networks based on FOBI relationships.
#'
#' @param terms A character vector with FOBI term IDs.
#' @param get A character string indicating desired relationships between provided terms. Options are 'anc' (for ancestors) and 'des' (for descendants). Default is NULL and all information related with input terms will be provided.
#' @param property A character vector indicating which properties should be plotted. Options are 'is_a', 'BiomarkerOf', and 'Contains'. By default all of them are included.
#' @param layout A character string indicating the type of layout to create. Options are 'sugiyama' (default) and 'lgl'.
#' @param labels Logical indicating if node names should be plotted or not.
#' @param labelsize Numeric value indicating the size of labels.
#' @param legend Logical indicating if legend should be plotted or not.
#' @param legendSize Numeric value indicating the size of legend.
#' @param legendPos A character string indicating the legend position (if legend parameter is set to TRUE). Options are 'bottom' (default) and 'top'.
#' @param curved Logical indicating if the shape of the edges shape should be curved or not.
#' @param pointSize Numeric value indicating the size of graph points.
#' @param fobi FOBI table obtained with `parse_fobi()`. If this value is set to NULL, the last version of FOBI will be downloaded from GitHub.
#'
#' @export
#'
#' @return A ggraph object.
#' @references Pol Castellano-Escuder, Raúl González-Domínguez, David S Wishart, Cristina Andrés-Lacueva, Alex Sánchez-Pla, FOBI: an ontology to represent food intake data and associate it with metabolomic data, Database, Volume 2020, 2020, baaa033, https://doi.org/10.1093/databa/baaa033.
#' @author Pol Castellano-Escuder
#'
#' @examples
#' 
#' terms <- c("CHEBI:16164","CHEBI:16243","FOODON:00001139","FOODON:00003274","FOODON:00003275")
#' fobi_graph(terms, get = "anc")
#' 
#' # Red meat related FOBI biomarkers
#' fobi_graph(terms = "FOBI:0193", 
#'            property = c("is_a", "BiomarkerOf"), 
#'            layout = "lgl", curved = TRUE) # set labels = TRUE to display node names
#' 
#' @import ggraph
#' @import ggplot2
#' @import tidygraph
#' @importFrom magrittr %>%
#' @importFrom dplyr filter mutate select rename
#' @importFrom ontologyIndex get_descendants get_ancestors
fobi_graph <- function(terms = NULL,
                       get = NULL,
                       property = c("is_a", "BiomarkerOf", "Contains"),
                       layout = "sugiyama",
                       labels = FALSE,
                       labelsize = 3,
                       legend = FALSE,
                       legendSize = 10,
                       legendPos = "bottom",
                       curved = FALSE,
                       pointSize = 3,
                       fobi = fobitools::fobi){
  
  if (is.null(terms)) {
    stop("No terms are provided")
  }
  if (!is.null(get)){
    if (!(get %in% c("anc", "des"))) {
      stop("Incorrect value for get argument. Options are 'anc' (for ancestors) and 'des' (for descendants)")
    }
  }
  if (!all(property %in% c("is_a", "BiomarkerOf", "Contains"))) {
    stop("Incorrect value for property argument. Options are 'is_a', 'BiomarkerOf', and 'Contains'")
  }
  if (!(layout %in% c("sugiyama", "lgl"))) {
    stop("Incorrect value for layout argument. Options are 'sugiyama' (default) and 'lgl'")
  }
  if (!(legendPos %in% c("bottom", "top"))) {
    stop("Incorrect value for legendPos argument. Options are 'bottom' (default) and 'top'")
  }
  
  if (is.null(fobi)){
    fobi_foods <- parse_fobi(terms = "FOBI:0001", get = "des")
    
    fobiGraph <- parse_fobi(terms = terms, get = get) %>%
      filter(!is.na(is_a_code))
  } else {
    fobi_foods <- fobitools::foods
    
    if (!is.null(get)){
      if(get == "des"){
        fobi_des <- fobitools::fobi_terms %>%
          ontologyIndex::get_descendants(roots = terms, exclude_roots = TRUE)
        
        fobiGraph <- fobi %>%
          filter(id_code %in% fobi_des) %>%
          filter(!is.na(is_a_code))
      }
      else {
        fobi_anc <- fobitools::fobi_terms %>%
          ontologyIndex::get_ancestors(terms = terms)
        
        fobiGraph <- fobi %>%
          filter(id_code %in% fobi_anc) %>%
          filter(!is.na(is_a_code))
      }
    } else {
      
      fobiGraph <- fobi %>%
        filter(id_code %in% terms) %>%
        filter(!is.na(is_a_code))
    }
  }
  
  ##
  
  contains <- fobiGraph %>%
    mutate(Property = ifelse(!is.na(Contains), "Contains", NA)) %>%
    filter(!is.na(Property)) %>%
    select(name, Contains, Property) %>%
    rename(from = name, to = Contains)
  
  biomarkerof <- fobiGraph %>%
    mutate(Property = ifelse(!is.na(BiomarkerOf), "BiomarkerOf", NA)) %>%
    filter(!is.na(Property)) %>%
    select(name, BiomarkerOf, Property) %>%
    rename(from = name, to = BiomarkerOf)
  
  is_a <- fobiGraph %>%
    select(name, is_a_name) %>%
    mutate(Property = "is_a") %>%
    filter(!duplicated(name)) %>%
    rename(from = name, to = is_a_name)
  
  if(sum(nrow(is_a), nrow(biomarkerof), nrow(contains)) < 1) {
    stop("No terms with these characteristics")
  }
  
  ##
  
  graph_table <- rbind(is_a, biomarkerof, contains) %>%
    filter(Property %in% property) %>%
    as_tbl_graph() %>%
    mutate(subOntology = ifelse(name %in% fobi_foods$name, "Food", "Biomarker"),
           subOntology = ifelse(name == "Foods", "Food", subOntology))
  
  cols_nodes <- c("Biomarker" = "#440154FF", 
                  "Food" = "#FDE725FF") # viridis palette
  
  cols_edges <- c("is_a" = "#287C8EFF", 
                  "BiomarkerOf" = "#75D054FF", 
                  "Contains" = "#E3E418FF") # viridis palette
  
  ggraph(graph_table, layout = layout) +
    {if(!curved) geom_edge_link(aes(color = Property), end_cap = circle(2.5, "mm"), 
                                arrow = arrow(length = unit(2.5, "mm"), type = "closed"),
                                show.legend = legend)} +
    {if(curved) geom_edge_arc(aes(color = Property), end_cap = circle(2.5, "mm"),
                              arrow = arrow(length = unit(2.5, "mm"), type = "closed"),
                              strength = 0.1, show.legend = legend)} +
    geom_node_point(aes(color = subOntology, shape = subOntology), size = pointSize, show.legend = FALSE) +
    {if(labels)geom_node_text(aes(label = name), color = "black", size = labelsize, repel = TRUE, show.legend = FALSE)} +
    scale_color_manual(values = cols_nodes, guide = "none") +
    scale_shape_manual(values = c("Biomarker" = 16, "Food" = 15), guide = "none") +
    scale_edge_color_manual(values = cols_edges) +
    theme_graph(foreground = "white", fg_text_colour = "white") + 
    theme(legend.title = element_blank(),
          legend.text = element_text(size = legendSize),
          legend.position = legendPos)

  }

context("fobi_graph")

test_that("fobi_graph works", {
  
  terms <- c("CHEBI:16164", "CHEBI:16243", "FOODON:00001139", "FOODON:00003274", "FOODON:00003275")
  
  a <- fobi_graph(terms, get = "anc")
  b <- fobi_graph(terms, get = "anc", property = c("is_a", "BiomarkerOf", "Contains"), labels = TRUE)
  c <- fobi_graph(terms, get = "anc", labels = TRUE, legend = TRUE, fobi = NULL)
  d <- fobi_graph(terms, get = "anc", property = c("is_a", "BiomarkerOf"), labels = TRUE, legend = TRUE, curved = TRUE)
  e <- fobi_graph(terms = "FOODON:00002473", property = c("is_a", "Contains"), labels = TRUE, legend = TRUE, labelsize = 5, fobi = NULL)
  
  ##
  
  expect_true(class(a)[1] == "ggraph")
  expect_true(class(b)[1] == "ggraph")
  expect_true(class(c)[1] == "ggraph")
  expect_true(class(d)[1] == "ggraph")
  expect_true(class(e)[1] == "ggraph")
  
  ##
  
  expect_error(fobi_graph(get = "anc"))
  expect_error(fobi_graph(terms, get = "ance"))
  expect_error(fobi_graph(terms, get = "anc", layout = "fr"))
  expect_error(fobi_graph(terms, get = "anc", legendPos = "left"))
  expect_error(fobi_graph(terms = c("FOBI:01501", "FOBI:0001"), get = "des", property = c("is_a", "Biomarker_of", "Contains"))) # Biomarker_of instead of BiomarkerOf
  expect_error(fobi_graph(terms = c("FOBI:01501", "FOBI:0001"), get = "anc", legend = TRUE))
  
  })

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----eval = FALSE-------------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("fobitools")

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
library(fobitools)

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
# CRAN
library(tidyverse)
library(ggrepel)
library(kableExtra)

# Bioconductor
library(POMA)
library(metabolomicsWorkbenchR)
library(SummarizedExperiment)

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
data <- do_query(
  context = "study",
  input_item = "analysis_id",
  input_value = "AN000961",
  output_item = "SummarizedExperiment")

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
## features 
features <- assay(data)
rownames(features) <- rowData(data)$metabolite

## metadata
pdata <- colData(data) %>%
  as.data.frame() %>%
  tibble::rownames_to_column("ID") %>%
  relocate(grouping, .before = Sodium.level) %>%
  mutate(grouping = case_when(grouping == "A(salt sensitive)" ~ "A",
                              grouping == "B(salt insensitive)" ~ "B"))

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
data_sumexp <- PomaCreateObject(metadata = pdata, features = t(features))

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
data_preprocessed <- data_sumexp %>%
  PomaImpute(group_by = "grouping") %>%
  PomaNorm()

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
limma_res <- data_preprocessed %>%
  PomaLimma(contrast = "A-B", adjust = "fdr") %>%
  dplyr::rename(ID = feature)

# show the first 10 features
limma_res %>%
  dplyr::slice(1L:10L) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))

## ----warning = FALSE, message = FALSE, comment = FALSE, eval = FALSE----------
# cat(limma_res$ID, sep = "\n")

## ----MAconvertID, message = FALSE, warning = FALSE, comment = FALSE, echo = FALSE, fig.align = "center", out.width = "100%", fig.cap = 'Metabolite names conversion using MetaboAnalyst.'----
knitr::include_graphics("figure/MetaboAnalyst_convertID.png")

## ----warning = FALSE, message = FALSE, comment = FALSE, eval = FALSE----------
# ST000629_MetaboAnalyst_MapNames <- readr::read_delim("https://www.metaboanalyst.ca/MetaboAnalyst/resources/users/XXXXXXX/name_map.csv", delim = ",")

## ----warning = FALSE, message = FALSE, comment = FALSE, echo = FALSE----------
load("data/ST000629_MetaboAnalyst_MapNames.rda")

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
annotated_limma <- ST000629_MetaboAnalyst_MapNames %>%
  dplyr::rename(ID = Query) %>%
  dplyr::mutate(ID = tolower(ID)) %>% 
  dplyr::right_join(limma_res %>% 
                      dplyr::mutate(ID = tolower(ID)),
                    by = "ID")

limma_FOBI_names <- annotated_limma %>%
  dplyr::pull("KEGG") %>%
  fobitools::id_convert(to = "FOBI")

# show the ID conversion results
limma_FOBI_names %>%
  head() %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
limma_FOBI_names <- limma_FOBI_names %>%
  dplyr::right_join(annotated_limma, by = "KEGG") %>%
  dplyr::select(FOBI, KEGG, ID, log2FC, pvalue, adj_pvalue) %>%
  dplyr::arrange(-dplyr::desc(pvalue))

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
metaboliteList <- limma_FOBI_names$FOBI[limma_FOBI_names$pvalue < 0.05]
metaboliteUniverse <- limma_FOBI_names$FOBI

fobitools::ora(metaboliteList = metaboliteList,
               metaboliteUniverse = metaboliteUniverse,
               pvalCutoff = 1) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
limma_FOBI_msea <- limma_FOBI_names %>%
  select(FOBI, pvalue) %>%
  filter(!is.na(FOBI)) %>%
  dplyr::arrange(-dplyr::desc(abs(pvalue)))

FOBI_msea <- as.vector(limma_FOBI_msea$pvalue)
names(FOBI_msea) <- limma_FOBI_msea$FOBI

msea_res <- fobitools::msea(FOBI_msea, pvalCutoff = 1)

msea_res %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))

## ----warning = FALSE, message = FALSE, comment = FALSE, fig.width = 12, fig.height = 8----
ggplot(msea_res, aes(x = -log10(pval), y = NES, color = NES, size = classSize, label = className)) +
  xlab("-log10(P-value)") +
  ylab("NES (Normalized Enrichment Score)") +
  geom_point() +
  ggrepel::geom_label_repel(color = "black", size = 7) +
  theme_bw() +
  theme(legend.position = "top",
        text = element_text(size = 22)) +
  scale_color_viridis_c() +
  scale_size(guide = "none")

## ----warning = FALSE, message = FALSE, comment = FALSE, fig.width = 12, fig.height = 10----
FOBI_terms <- msea_res %>%
  unnest(cols = leadingEdge)

fobitools::fobi %>%
  filter(FOBI %in% FOBI_terms$leadingEdge) %>%
  pull(id_code) %>%
  fobi_graph(get = "anc",
             labels = TRUE,
             legend = TRUE,
             labelsize = 6,
             legendSize = 20)

## -----------------------------------------------------------------------------
sessionInfo()

#' Text Mining Pipeline to Annotate Free Nutritional Text with FOBI
#'
#' @description This function provides a text mining pipeline to map nutritional free text to Food-Biomarker Ontology. This pipeline is composed of five sequential layers to map food items to FOBI with the maximum accuracy as possible.
#'
#' @param foods A two column data frame. First column must contain the ID (should be unique) and the second column must contain food items (it can be a word or a string).
#' @param similarity Numeric between 0 (low) and 1 (high). This value indicates the semantic similarity cutoff used at the last layer of the text mining pipeline. 1 = exact match; 0 = very poor match. Values below 0.85 are not recommended.
#' @param reference FOBI foods table obtained with `parse_fobi(terms = "FOBI:0001", get = "des")`. If this value is set to NULL, the last version of FOBI will be downloaded from GitHub.
#' 
#' @export
#'
#' @return A list containing two tibble objects: annotated and unannotated food items.
#' @references Pol Castellano-Escuder, Raúl González-Domínguez, David S Wishart, Cristina Andrés-Lacueva, Alex Sánchez-Pla, FOBI: an ontology to represent food intake data and associate it with metabolomic data, Database, Volume 2020, 2020, baaa033, https://doi.org/10.1093/databa/baaa033.
#' @author Pol Castellano-Escuder
#'
#' @examples
#' 
#' # Free text annotation in FOBI
#' free_text <- data.frame(id = c(101, 102, 103, 104),
#'                         text = c("Yesterday I ate eggs and bacon with a butter toast and black tea", 
#'                                  "Crisp bread and rice crackers with wholegrain", 
#'                                  "Beef and veal, one apple", "pizza without meat"))
#' annotate_foods(free_text)
#' 
#' @importFrom magrittr %>%
#' @importFrom clisymbols symbol
#' @importFrom tictoc tic toc
#' @importFrom tidyr separate_rows expand_grid
#' @importFrom dplyr mutate select rename filter ungroup mutate_all group_by bind_rows summarise as_tibble slice left_join
#' @importFrom stringr str_replace_all str_trim str_squish str_remove_all str_detect str_replace
#' @importFrom textclean make_plural
#' @importFrom RecordLinkage jarowinkler 
#' @importFrom crayon red yellow green
annotate_foods <- function(foods,
                           similarity = 0.85,
                           reference = fobitools::foods){
  
  tictoc::tic()
  
  if(ncol(foods) != 2){
    stop("Input must be a two-column data frame")
  }
  if(similarity > 1 | similarity < 0){
    stop("Similarity parameter must be a numeric value between 0 and 1")
  }
  
  foods <- foods %>%
    dplyr::rename(FOOD_ID = 1, FOOD_NAME = 2) %>%
    filter(!duplicated(FOOD_NAME))
  
  dup_ids <- foods %>%
    filter(duplicated(FOOD_ID))
  
  if(nrow(dup_ids) > 0){
    stop("Duplicated IDs are not allowed")
  }
  
  if (is.null(reference)){
    reference <- fobitools::parse_fobi(terms = "FOBI:0001", get = "des")
  }
  
  remove_patterns <- c("\\bproducts\\b",
                       "\\bproduct\\b",
                       "\\bwhole\\b",
                       "\\braw\\b",
                       "\\bfoods\\b",
                       "\\bfood\\b",
                       "\\bplant\\b",
                       "\\bbased\\b",
                       "\\bbeverage\\b",
                       "\\bor\\b",
                       "\\bon\\b",
                       "\\bother\\b",
                       "\\bfried\\b",
                       "\\bboiled\\b")
  
  ffq <- foods %>%
    mutate(words = str_replace_all(FOOD_NAME, "," , " and "),
           words = str_replace_all(words, ";" , " and "),
           words = str_replace_all(words, "[[:punct:]]" , " "),
           words = str_replace_all(words, "[[:digit:]]", " "),
           words = str_trim(words),
           words = str_squish(words),
           words = tolower(words)) %>%
    separate_rows(words, sep = "\\bwith\\b") %>%
    separate_rows(words, sep = "\\band\\b") %>%
    mutate(words = str_remove_all(words, pattern = paste(remove_patterns, collapse = "|")),
           words = ifelse(str_detect(words, "\\bwithout meat\\b"), paste0("vegetarian ", words), words), # without meat
           words = str_remove_all(words, "\\without.*"),
           words = str_remove_all(words, "\\for.*"), # to discuss
           words = str_remove_all(words, ".*free"), # to discuss
           words = str_trim(words),
           words = str_squish(words)) %>%
    group_by(FOOD_ID) %>%
    mutate(words_joint = paste(words, collapse = " "),
           words_joint = str_trim(words_joint),
           words_joint = str_squish(words_joint)) %>%
    ungroup() %>%
    filter(!duplicated(FOOD_ID)) %>%
    select(-words) %>%
    dplyr::rename(words = words_joint)
  
  remove_patterns2 <- c("\\bproducts\\b",
                        "\\bproduct\\b",
                        "\\bwhole\\b",
                        "\\braw\\b",
                        "\\bfoods\\b",
                        "\\bfood\\b",
                        "\\bplant\\b",
                        "\\bbased\\b",
                        "\\bbeverage\\b",
                        "\\bor\\b",
                        "\\band\\b",
                        "\\bother\\b")

  fobi_foods <- reference %>% 
    select(id_code, name) %>%
    mutate_all(unlist) %>%
    mutate(ref = tolower(name),
           ref = str_replace(ref, "\\(.*\\)", ""),
           ref = str_remove_all(ref, pattern = paste(remove_patterns2, collapse = "|")),
           ref = str_replace_all(ref, pattern = "\\brice grain\\b", replacement = "rice"), # specific case
           ref = str_replace_all(ref, pattern = "\\bsoybean\\b", replacement = "soy"), # specific case
           ref = str_replace_all(ref, pattern = "\\bbarley grain \\b", replacement = "barley"), # specific case
           ref = str_replace_all(ref, pattern = "\\bpork ribs\\b", replacement = "pork"), # specific case
           ref = str_trim(ref),
           ref = str_squish(ref)) %>%
    filter(ref != "")
  
  #### START
  
  # RAW MATCH
  
  wordlist <- expand_grid(words = ffq$words, ref = fobi_foods$ref) %>%
    mutate(detect = stringr::str_detect(words, paste0("\\b", ref, "\\b"))) %>%
    filter(ref == words | detect == "TRUE") %>%
    select(-detect)
  
  result0 <- merge(ffq, wordlist, by = "words")
  result0 <- merge(result0, fobi_foods, by = "ref") %>%
    select(FOOD_ID, FOOD_NAME, id_code, name) %>%
    filter(!duplicated(.))
  
  no_matched <- ffq %>% filter(!FOOD_NAME %in% result0$FOOD_NAME)
  
  # RAW MATCH (SINGULARS AND PLURALS WITHOUT WHITESPACES)
  
  ffq_sing <- ffq %>% 
    filter(FOOD_NAME %in% no_matched$FOOD_NAME) %>%
    mutate(words = str_replace_all(words, c("[^[:alnum:]]$" = "",  "s$" = "", "(\\(\\d*)" = "\\1\\)")))
  
  ffq_sing_nospace <- ffq_sing %>%
    mutate(words = str_replace_all(words, " ", ""))
    
  ffq_plural <- ffq %>% 
    filter(FOOD_NAME %in% no_matched$FOOD_NAME) %>%
    mutate(words = textclean::make_plural(words))
  
  ffq_plural_nospace <- ffq_plural %>%
    mutate(words = str_replace_all(words, " ", ""))
  
  ffq_no_space <- ffq %>% 
    filter(FOOD_NAME %in% no_matched$FOOD_NAME) %>%
    mutate(words = str_replace_all(words, " ", ""))
  
  ffq1 <- bind_rows(ffq_sing, ffq_sing_nospace, ffq_plural, ffq_plural_nospace, ffq_no_space)
  
  wordlist <- expand_grid(words = ffq1$words, ref = fobi_foods$ref) %>%
    mutate(detect = stringr::str_detect(words, paste0("\\b", ref, "\\b"))) %>%
    filter(ref == words | detect == "TRUE") %>%
    select(-detect)
  
  result1 <- merge(ffq1, wordlist, by = "words")
  result1 <- merge(result1, fobi_foods, by = "ref") %>%
    select(FOOD_ID, FOOD_NAME, id_code, name) %>%
    filter(!duplicated(.))
  
  no_matched <- ffq1 %>% filter(!FOOD_NAME %in% result0$FOOD_NAME, 
                                !FOOD_NAME %in% result1$FOOD_NAME)
  
  # SPLIT INPUT (SINGULARS AND PLURALS)
  
  ffq_sep <- ffq %>%
    filter(FOOD_NAME %in% no_matched$FOOD_NAME) %>%
    separate_rows(words, sep = " ")
  
  ffq_sep_sing <- ffq_sep %>%
    mutate(words = str_replace_all(words, c("[^[:alnum:]]$" = "",  "s$" = "", "(\\(\\d*)" = "\\1\\)")))
  
  ffq_sep_plural <- ffq_sep %>%
    mutate(words = textclean::make_plural(words))
  
  ffq_sep <- bind_rows(ffq_sep, ffq_sep_sing, ffq_sep_plural)
  
  wordlist <- expand_grid(words = ffq_sep$words, ref = fobi_foods$ref) %>%
    mutate(detect = stringr::str_detect(words, paste0("\\b", ref, "\\b"))) %>%
    filter(ref == words | detect == "TRUE") %>%
    select(-detect)
  
  result2 <- merge(ffq_sep, wordlist, by = "words")
  result2 <- merge(result2, fobi_foods, by = "ref") %>%
    filter(!duplicated(.)) %>%
    group_by(FOOD_ID) %>%
    mutate(id_code = paste(id_code, collapse = ";"),
           name = paste(name, collapse = ";")) %>%
    select(FOOD_ID, FOOD_NAME, id_code, name) %>%
    ungroup() %>%
    filter(!duplicated(.))
  
  no_matched <- ffq %>% filter(!FOOD_NAME %in% result0$FOOD_NAME, 
                               !FOOD_NAME %in% result1$FOOD_NAME,
                               !FOOD_NAME %in% result2$FOOD_NAME)
  
  # SPLIT REFERENCE (SINGULARS AND PLURALS)
  
  fobi_foods_sep <- fobi_foods %>% 
    separate_rows(ref, sep = " ")
  
  fobi_foods_sep_sing <- fobi_foods_sep %>%
    mutate(ref = str_replace_all(ref, c("[^[:alnum:]]$" = "",  "s$" = "", "(\\(\\d*)" = "\\1\\)")))
  
  fobi_foods_sep_plural <- fobi_foods_sep %>%
    mutate(ref = textclean::make_plural(ref))
  
  fobi_foods_sep <- bind_rows(fobi_foods_sep, fobi_foods_sep_sing, fobi_foods_sep_plural)
  
  ffq2 <- ffq %>% 
    filter(FOOD_NAME %in% no_matched$FOOD_NAME)
  
  wordlist <- expand_grid(words = ffq2$words, ref = fobi_foods_sep$ref) %>%
    mutate(detect = stringr::str_detect(words, paste0("\\b", ref, "\\b"))) %>%
    filter(ref == words | detect == "TRUE") %>%
    select(-detect)
  
  result3 <- merge(ffq2, wordlist, by = "words")
  result3 <- merge(result3, fobi_foods_sep, by = "ref") %>%
    select(FOOD_ID, FOOD_NAME, id_code, name) %>%
    filter(!duplicated(.))
  
  no_matched <- ffq %>% filter(!FOOD_NAME %in% result0$FOOD_NAME, 
                               !FOOD_NAME %in% result1$FOOD_NAME,
                               !FOOD_NAME %in% result2$FOOD_NAME,
                               !FOOD_NAME %in% result3$FOOD_NAME)
  
  # RAW SEMANTIC SIMILARITY
  
  ffq3 <- ffq %>%
    filter(FOOD_NAME %in% no_matched$FOOD_NAME)
  
  wordlist <- expand_grid(words = ffq3$words, ref = fobi_foods$ref) %>%
    group_by(words) %>%
    mutate(match_score = RecordLinkage::jarowinkler(words, ref)) %>%
    summarise(match = match_score[which.max(match_score)], ref = ref[which.max(match_score)])
  
  result4 <- merge(ffq3, wordlist, by = "words")
  result4 <- merge(result4, fobi_foods, by = "ref") %>%
    filter(match >= similarity) %>%
    select(FOOD_ID, FOOD_NAME, id_code, name) %>%
    filter(!duplicated(.))
  
  no_matched <- ffq3 %>% filter(!FOOD_NAME %in% result0$FOOD_NAME,
                                !FOOD_NAME %in% result1$FOOD_NAME,
                                !FOOD_NAME %in% result2$FOOD_NAME,
                                !FOOD_NAME %in% result3$FOOD_NAME,
                                !FOOD_NAME %in% result4$FOOD_NAME) %>%
    select(-words) %>%
    as_tibble()
  
  ## MERGE RESULTS
  
  annotated_input <- bind_rows(result0, result1, result2, result3, result4) %>% 
    separate_rows(id_code, sep = ";") %>%
    separate_rows(name, sep = ";") %>%
    mutate_all(as.character) %>%
    select(-id_code) %>%
    mutate(grouping = paste0(FOOD_ID, "_", name)) %>% 
    group_by(grouping) %>%
    dplyr::slice(1) %>%
    ungroup() %>%
    select(-grouping) %>%
    left_join(reference, by = "name") %>%
    select(FOOD_ID, FOOD_NAME, id_code, name) %>%
    dplyr::rename(FOBI_ID = id_code, FOBI_NAME = name) %>%
    filter(!duplicated(.)) %>%
    as_tibble()
  
  ## OUTPUT MESSAGE
  
  if (round(100 - ((nrow(no_matched)/nrow(foods))*100), 2) > 75){
    cat(crayon::green(paste0(round(100 - ((nrow(no_matched)/nrow(foods))*100), 2), "% annotated\n")))
  }
  else if (round(100 - ((nrow(no_matched)/nrow(foods))*100), 2) > 25){
    cat(crayon::yellow(paste0(round(100 - ((nrow(no_matched)/nrow(foods))*100), 2), "% annotated\n")))
  }
  else {
    cat(crayon::red(paste0(round(100 - ((nrow(no_matched)/nrow(foods))*100), 2), "% annotated\n")))
  }
  
  tictoc::toc()
  
  return(list(annotated = annotated_input, unannotated = no_matched))
  
}

context("annotate_foods")

test_that("annotate_foods works", {
  
  # Dummy free text
  free_text <- data.frame(id = c(101, 102, 103, 104),
                          text = c("Yesterday I ate eggs and bacon with a butter toast and black tea", 
                                   "Crisp bread and rice crackers with wholegrain", 
                                   "Beef and veal, one apple", "pizza without meat"))
  
  free_text_wrong <- data.frame(id = c(101, 102, 103, 104),
                                text = c("Yesterday I ate eggs and bacon with a butter toast and black tea", 
                                         "Crisp bread and rice crackers with wholegrain", 
                                         "Beef and veal, one apple", "pizza without meat"),
                                id_2 = c(1,2,3,4))
  
  free_text_dup <- data.frame(id = c(101, 101, 103, 104),
                              text = c("Yesterday I ate eggs and bacon with a butter toast and black tea", 
                                       "Crisp bread and rice crackers with wholegrain", 
                                       "Beef and veal, one apple", "pizza without meat"))
  
  a <- annotate_foods(free_text)
  b <- annotate_foods(free_text, similarity = 0.7)
  c <- annotate_foods(free_text, similarity = 1, reference = NULL)
  
  ##
  
  expect_equal(ncol(a), ncol(b))
  expect_equal(ncol(b), ncol(c))
  
  ##
  
  expect_true(class(a) == "list")
  expect_true(class(b) == "list")
  expect_true(class(c) == "list")
  
  expect_true(class(a$annotated)[2] == "tbl")
  expect_true(class(b$annotated)[2] == "tbl")
  expect_true(class(c$annotated)[2] == "tbl")
  
  expect_true(class(a$unannotated)[2] == "tbl")
  expect_true(class(b$unannotated)[2] == "tbl")
  expect_true(class(c$unannotated)[2] == "tbl")
  
  ##
  
  expect_error(annotate_foods(free_text, similarity = 1.01))
  expect_error(annotate_foods(free_text, similarity = -1))
  expect_error(annotate_foods(free_text_wrong))
  expect_error(annotate_foods(free_text_dup))
  
})

#' FOBI Identifier Map File - Jul 18, 2021
#'
#' Identifier mappings for FOBI metabolites 
#'
#' @format A tibble: 590 FOBI metabolites with 8 different IDs.
#' \describe{
#'   \item{metaboliteNames}{Raw metabolite names.}
#'   \item{FOBI}{FOBI ID.}
#'   \item{HMDB}{HMDB ID.}
#'   \item{KEGG}{KEGG ID.}
#'   \item{PubChemCID}{PubChemCID ID.}
#'   \item{InChIKey}{InChIKey ID.}
#'   \item{InChICode}{InChICode ID.}
#'   \item{ChemSpider}{ChemSpider ID.}
#' }
#' @source \url{https://github.com/pcastellanoescuder/FoodBiomarkerOntology}
"idmap"

#' FOBI Table File - Jul 23, 2021
#'
#' FOBI table obtained with `parse_fobi()`
#'
#' @format A tibble: 4069 FOBI entities with their associated information.
#' \describe{
#'   \item{id_code}{FOBI entity ID.}
#'   \item{name}{FOBI entity name.}
#'   \item{is_a_code}{FOBI entity direct parent class ID.}
#'   \item{is_a_name}{FOBI entity direct parent class name.}
#'   \item{id_BiomarkerOf}{FOBI entity associated food ID (in terms of biomarker).}
#'   \item{BiomarkerOf}{FOBI entity associated food name (in terms of biomarker).}
#'   \item{ChemSpider}{ChemSpider ID.}
#'   \item{KEGG}{KEGG ID.}
#'   \item{PubChemCID}{PubChemCID ID.}
#'   \item{InChIKey}{InChIKey ID.}
#'   \item{InChICode}{InChICode ID.}
#'   \item{FOBI}{FOBI ID.}
#'   \item{alias}{FOBI entity alias name.}
#'   \item{HMDB}{HMDB ID.}
#'   \item{id_Contains}{FOBI entity associated food ID (in terms of a recipe).}
#'   \item{Contains}{FOBI entity associated food ID (in terms of a recipe).}
#' }
#' @source \url{https://github.com/pcastellanoescuder/FoodBiomarkerOntology}
"fobi"

#' FOBI Foods Table File - Feb 02, 2021
#'
#' FOBI foods table obtained with `parse_fobi(terms = "FOBI:0001", get = "des")`
#'
#' @format A tibble: 568 FOBI food entities with their associated information.
#' \describe{
#'   \item{id_code}{FOBI entity ID.}
#'   \item{name}{FOBI entity name.}
#'   \item{is_a_code}{FOBI entity direct parent class ID.}
#'   \item{is_a_name}{FOBI entity direct parent class name.}
#'   \item{id_BiomarkerOf}{FOBI entity associated food ID (in terms of biomarker).}
#'   \item{BiomarkerOf}{FOBI entity associated food name (in terms of biomarker).}
#'   \item{ChemSpider}{ChemSpider ID.}
#'   \item{KEGG}{KEGG ID.}
#'   \item{PubChemCID}{PubChemCID ID.}
#'   \item{InChIKey}{InChIKey ID.}
#'   \item{InChICode}{InChICode ID.}
#'   \item{FOBI}{FOBI ID.}
#'   \item{alias}{FOBI entity alias name.}
#'   \item{HMDB}{HMDB ID.}
#'   \item{id_Contains}{FOBI entity associated food ID (in terms of a recipe).}
#'   \item{Contains}{FOBI entity associated food ID (in terms of a recipe).}
#' }
#' @source \url{https://github.com/pcastellanoescuder/FoodBiomarkerOntology}
"foods"

#' FOBI's `ontology_index` object - Jul 23, 2021
#'
#' FOBI terms obtained with `ontologyIndex::get_ontology()`
#'
#' @format An ontology_index object with 1201 terms.
#' \describe{
#'   \item{format-version:}{1.2}
#'   \item{data-version:}{fobi.owl}
#'   \item{ontology}{fobi}
#'   \item{Properties}{
#'   	id: character,
#'   	name: character,
#'   	parents: list,
#'   	children: list,
#'   	ancestors: list,
#'   	obsolete: logical}
#'   \item{Roots}{
#'   FOBI:0001 - Foods,
#'   FOBI:01501 - Biomarkers,
#'   FOBI:00422 - BiomarkerOf,
#'   FOBI:00423 - HasBiomarker,
#'   FOBI:00424 - Contains,
#'   FOBI:00425 - IsIngredientOf}
#' }
#' @source \url{https://github.com/pcastellanoescuder/FoodBiomarkerOntology}
"fobi_terms"

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----eval = FALSE-------------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("fobitools")

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
library(fobitools)

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
# CRAN
library(tidyverse)
library(rvest)
library(ggrepel)
library(kableExtra)

# Bioconductor
library(POMA)
library(metabolomicsWorkbenchR)
library(SummarizedExperiment)

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
data_negative_mode <- do_query(
  context = "study",
  input_item = "analysis_id",
  input_value = "AN000465",
  output_item = "SummarizedExperiment")

data_positive_mode <- do_query(
  context = "study",
  input_item = "analysis_id",
  input_value = "AN000464",
  output_item = "SummarizedExperiment")

## ----metabolitenames, message = FALSE, warning = FALSE, comment = FALSE, echo = FALSE, fig.align = "center", out.width = "100%", fig.cap = 'Metabolite identifiers of the ST000291 Metabolomics Workbench study.'----
knitr::include_graphics("figure/ST000291_names.png")

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
metaboliteNamesURL <- "https://www.metabolomicsworkbench.org/data/show_metabolites_by_study.php?STUDY_ID=ST000291&SEARCH_TYPE=KNOWN&STUDY_TYPE=MS&RESULT_TYPE=1"
metaboliteNames <- metaboliteNamesURL %>% 
  read_html() %>% 
  html_nodes(".datatable")

metaboliteNames_negative <- metaboliteNames %>%
  .[[1]] %>%
  html_table() %>%
  dplyr::select(`Metabolite Name`, PubChemCompound_ID, `Kegg Id`)

metaboliteNames_positive <- metaboliteNames %>%
  .[[2]] %>%
  html_table() %>%
  dplyr::select(`Metabolite Name`, PubChemCompound_ID, `Kegg Id`)

metaboliteNames <- bind_rows(metaboliteNames_negative, metaboliteNames_positive) %>%
  dplyr::rename(names = 1, PubChem = 2, KEGG = 3) %>%
  mutate(KEGG = ifelse(KEGG == "-", "UNKNOWN", KEGG),
         PubChem = ifelse(PubChem == "-", "UNKNOWN", PubChem)) %>%
  filter(!duplicated(PubChem))

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
## negative mode features 
features_negative <- assay(data_negative_mode) %>%
  dplyr::slice(-n())
rownames(features_negative) <- rowData(data_negative_mode)$metabolite[1:(length(rowData(data_negative_mode)$metabolite)-1)]

## positive mode features
features_positive <- assay(data_positive_mode) %>%
  dplyr::slice(-n())
rownames(features_positive) <- rowData(data_positive_mode)$metabolite[1:(length(rowData(data_positive_mode)$metabolite)-1)]

## combine positive and negative mode and set PubChem IDs as feature names
features <- bind_rows(features_negative, features_positive) %>%
  tibble::rownames_to_column("names") %>%
  right_join(metaboliteNames, by = "names") %>%
  select(-names, -KEGG) %>%
  tibble::column_to_rownames("PubChem")

## metadata
pdata <- colData(data_negative_mode) %>% # or "data_positive_mode". They are equal
  as.data.frame() %>%
  tibble::rownames_to_column("ID") %>%
  mutate(Treatment = case_when(Treatment == "Baseline urine" ~ "Baseline",
                               Treatment == "Urine after drinking apple juice" ~ "Apple",
                               Treatment == "Urine after drinking cranberry juice" ~ "Cranberry"))

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
data_sumexp <- PomaCreateObject(metadata = pdata, features = t(features))

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
data_preprocessed <- data_sumexp %>%
  PomaImpute(group_by = "Treatment") %>%
  PomaNorm()

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
limma_res <- data_preprocessed %>%
  PomaLimma(contrast = "Baseline-Cranberry", adjust = "fdr") %>%
  dplyr::rename(PubChemCID = feature) %>% 
  dplyr::mutate(PubChemCID = gsub("X", "", PubChemCID))

# show the first 10 features
limma_res %>%
  dplyr::slice(1L:10L) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
limma_FOBI_names <- limma_res %>%
  dplyr::pull("PubChemCID") %>%
  fobitools::id_convert()

# show the ID conversion results
limma_FOBI_names %>%
  head() %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
limma_FOBI_names <- limma_FOBI_names %>%
  dplyr::right_join(limma_res, by = "PubChemCID") %>%
  dplyr::arrange(-dplyr::desc(pvalue))

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
metaboliteList <- limma_FOBI_names$FOBI[limma_FOBI_names$pvalue < 0.01]
metaboliteUniverse <- limma_FOBI_names$FOBI

fobitools::ora(metaboliteList = metaboliteList,
               metaboliteUniverse = metaboliteUniverse,
               pvalCutoff = 0.5) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
limma_FOBI_msea <- limma_FOBI_names %>%
  dplyr::select(FOBI, pvalue) %>%
  dplyr::filter(!is.na(FOBI)) %>%
  dplyr::arrange(-dplyr::desc(abs(pvalue)))

FOBI_msea <- as.vector(limma_FOBI_msea$pvalue)
names(FOBI_msea) <- limma_FOBI_msea$FOBI

msea_res <- fobitools::msea(FOBI_msea, pvalCutoff = 0.06)

msea_res %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
fobi_graph(terms = c("FOODON:03301123", "FOODON:03301702"), 
           get = "anc", 
           labels = TRUE, 
           labelsize = 6)

## ----warning = FALSE, message = FALSE, comment = FALSE, fig.width = 12, fig.height = 8----
ggplot(msea_res, aes(x = -log10(pval), y = NES, color = NES, size = classSize, label = className)) +
  xlab("-log10(P-value)") +
  ylab("NES (Normalized Enrichment Score)") +
  geom_point() +
  ggrepel::geom_label_repel(color = "black", size = 7) +
  theme_bw() +
  theme(legend.position = "top",
        text = element_text(size = 22)) +
  scale_color_viridis_c() +
  scale_size(guide = "none")

## ----warning = FALSE, message = FALSE, comment = FALSE, fig.width = 12, fig.height = 10----
FOBI_terms <- msea_res %>% 
  unnest(cols = leadingEdge)

fobitools::fobi %>%
  filter(FOBI %in% FOBI_terms$leadingEdge) %>%
  pull(id_code) %>%
  fobi_graph(get = "anc", 
             labels = TRUE, 
             legend = TRUE, 
             labelsize = 6, 
             legendSize = 20)

## -----------------------------------------------------------------------------
sessionInfo()

#' Parse FOBI in a Readable Tabular Format
#'
#' @description This function allows users to download and parse the last version of the Food-Biomarker Ontology into a readable table format.
#'
#' @param terms A character vector with FOBI term IDs. Default is NULL.
#' @param get A character string indicating desired relationships between provided terms. Options are 'anc' (for ancestors) and 'des' (for descendants). Default is NULL and only information of single input terms will be provided.
#' 
#' @export
#'
#' @return A tibble with FOBI terms information.
#' @references Pol Castellano-Escuder, Raúl González-Domínguez, David S Wishart, Cristina Andrés-Lacueva, Alex Sánchez-Pla, FOBI: an ontology to represent food intake data and associate it with metabolomic data, Database, Volume 2020, 2020, baaa033, https://doi.org/10.1093/databa/baaa033.
#' @author Pol Castellano-Escuder
#'
#' @examples
#' 
#' # Download and parse whole FOBI
#' fobi <- parse_fobi()
#' 
#' # Download and parse 'apple' related terms
#' fobi_apple <- parse_fobi(terms = "FOODON:00002473")
#'
#' # Download and parse 'apple' term ancestors
#' fobi_apple_anc <- parse_fobi(terms = "FOODON:00002473", get = "anc")
#' 
#' # Download and parse 'apple' and 'alpha-Chaconine' related terms
#' fobi_subset <- parse_fobi(terms = c("FOODON:00002473", "CHEBI:10219"))
#' 
#' @importFrom magrittr %>%
#' @importFrom vroom vroom
#' @importFrom ontologyIndex get_ontology get_descendants
#' @importFrom tidyr drop_na separate_rows pivot_wider unnest
#' @importFrom dplyr slice mutate select rename filter n rowwise ungroup mutate_all
#' @importFrom stringr str_remove_all regex str_replace_all str_detect str_remove str_split
#' @importFrom purrr map
parse_fobi <- function(terms = NULL,
                       get = NULL){

  if (!is.null(get)){
    if (!(get %in% c("anc", "des"))) {
      stop("Incorrect value for get argument. Options are 'anc' (for ancestors) and 'des' (for descendants)")
    }
  }
  
  path <- "https://raw.github.com/pcastellanoescuder/FoodBiomarkerOntology/master/fobi.obo"
  
  fobi_terms <- ontologyIndex::get_ontology(path)
  
  if (!all(terms %in% fobi_terms$id)) {
    stop("Some of provided terms were not found in FOBI")
  }
  
  suppressMessages({
    raw_lines <- vroom::vroom(path, delim = ": ")
  })
  
  suppressWarnings({
      
    parsed_fobi <- raw_lines %>% 
      dplyr::slice(13:n()) %>%
      rename(V1 = 1, V2 = 2) %>%
      separate_rows(V2, sep = " ! ") %>% 
      mutate(V2 = str_replace_all(V2, pattern = "FOBI_", "FOBI:"),
             V2 = str_remove_all(V2, pattern = regex("xsd:string")),
             V1 = ifelse(V1 == "property_value", map(str_split(V2, pattern = " "), 1), V1),
             V1 = ifelse(V1 == "relationship", map(str_split(V2, pattern = " "), 1), V1),
             V1 = ifelse(str_detect(V1, pattern = "id") & str_detect(V2, pattern = regex(":")), "id_code", V1),
             V1 = ifelse(V1 == "id", "name", V1),
             V1 = ifelse(str_detect(V1, pattern = "is_a") & str_detect(V2, pattern = regex(":")), "is_a_code", V1),
             V1 = ifelse(V1 == "is_a", "is_a_name", V1),
             V2 = str_remove_all(V2, pattern = regex('["]'))) %>%
      drop_na() %>%
      rowwise() %>%
      mutate(V2 = str_remove(V2, pattern = V1)) %>%
      ungroup() %>%
      mutate_all(~ str_trim(.)) %>%
      mutate(gf = NA)
    
  })
  
  for(i in seq_len(nrow(parsed_fobi))){
    ifelse(parsed_fobi$V1[i] == "id_code", parsed_fobi$gf[i] <- i, parsed_fobi$gf[i] <- parsed_fobi$gf[i - 1])
  }
  
  fobi <- parsed_fobi %>%
    # group_by(gf) %>%
    pivot_wider(names_from = V1, values_from = V2, values_fn = list) %>%
    # ungroup() %>%
    select(-gf) %>%
    filter(!name %in% c("BiomarkerOf", "HasBiomarker", "Contains", "IsIngredientOf")) %>%
    select(id_code:Contains) %>%
    select(-disjoint_from, -`FOBI:050339`) %>%
    dplyr::rename(id_BiomarkerOf = "FOBI:00422",
                  ChemSpider = "FOBI:040232",
                  KEGG = "FOBI:040235",
                  PubChemCID = "FOBI:040236",
                  InChIKey = "FOBI:040237",
                  InChICode = "FOBI:040238",
                  FOBI = "FOBI:043480",
                  alias = "IAO:0000118",
                  HMDB = "FOBI:040233",
                  id_Contains = "FOBI:00424" #,
                  # PubmedID = "FOBI:050339"
                  ) %>%
    tidyr::unnest(cols = c(id_code:ChemSpider)) %>%
    tidyr::unnest(cols = c(KEGG:Contains))
  
  ##
  
  if (!is.null(terms) & is.null(get)){
    fobi <- fobi %>%
      filter(id_code %in% terms | is_a_code %in% terms | id_BiomarkerOf %in% terms | id_Contains %in% terms)
  }
  
  else if (!is.null(terms) & !is.null(get)){
    if(get == "des"){
      fobi_des <- fobi_terms %>%
        ontologyIndex::get_descendants(roots = terms, exclude_roots = TRUE)
      
      fobi <- fobi %>%
        filter(id_code %in% fobi_des)
    }
    else {
      fobi_anc <- fobi_terms %>%
        ontologyIndex::get_ancestors(terms = terms)
      
      fobi <- fobi %>%
        filter(id_code %in% fobi_anc)
    }
  }
  
  else if (is.null(terms) & !is.null(get)) {
    stop("No terms provided!")
  }
  
  return(fobi)
  
}

context("parse_fobi")

test_that("parse_fobi works", {
  
  a <- fobitools::parse_fobi(terms = "FOODON:00002473")
  b <- fobitools::parse_fobi(terms = "FOBI:01501")
  c <- fobitools::parse_fobi(terms = "FOBI:0001")
  d <- fobitools::parse_fobi()
  e <- fobitools::parse_fobi(terms = c("FOODON:00002473", "CHEBI:10219"))
  
  f <- fobitools::parse_fobi(terms = "FOODON:00002473", get = "anc")
  g <- fobitools::parse_fobi(terms = "FOODON:00002473", get = "des")
    
  ##
  
  expect_equal(ncol(a), ncol(b))
  expect_equal(ncol(b), ncol(c))
  expect_equal(ncol(c), ncol(d))
  expect_equal(ncol(f), ncol(g))
  
  ##
  
  expect_true(class(a)[2] == "tbl")
  expect_true(class(b)[2] == "tbl")
  expect_true(class(c)[2] == "tbl")
  expect_true(class(d)[2] == "tbl")
  
  expect_true(class(e)[2] == "tbl")
  expect_true(class(f)[2] == "tbl")
  expect_true(class(g)[2] == "tbl")
  
  ##
  
  expect_true(nrow(e) > nrow(a))
  expect_true(nrow(a) < nrow(d))
  expect_true(nrow(b) < nrow(d))
  expect_true(nrow(c) < nrow(d))
  expect_true(nrow(f) > nrow(g))
  
  ##
  
  nuts_id <- "FOBI:0135"
  expect_true(nuts_id %in% c$id_code)
  
  alkaloids_id <- "FOBI:040010"
  expect_true(alkaloids_id %in% b$id_code)
  
  ##
  
  expect_error(fobitools::parse_fobi(terms = "FOODON:00002473", get = "ances"))
  expect_error(fobitools::parse_fobi(terms = "FOODON:000024736666", get = "anc"))
  expect_error(fobitools::parse_fobi(get = "anc"))
  
})

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----eval = FALSE-------------------------------------------------------------
# # install.packages("BiocManager")
# BiocManager::install("fobitools")

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
library(fobitools)

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
library(dplyr)
library(kableExtra)

## ----warning = FALSE, message = FALSE, comment = FALSE------------------------
# select 300 random metabolites from FOBI
idx_universe <- sample(nrow(fobitools::idmap), 300, replace = FALSE)
metaboliteUniverse <- fobitools::idmap %>%
  dplyr::slice(idx_universe) %>%
  pull(FOBI)

# select 10 random metabolites from metaboliteUniverse that are associated with 'Red meat' (FOBI:0193), 
# 'Lean meat' (FOBI:0185) , 'egg food product' (FOODON:00001274), 
# or 'grape (whole, raw)' (FOODON:03301702)
fobi_subset <- fobitools::fobi %>% # equivalent to `parse_fobi()`
  filter(FOBI %in% metaboliteUniverse) %>%
  filter(id_BiomarkerOf %in% c("FOBI:0193", "FOBI:0185", "FOODON:00001274", "FOODON:03301702")) %>%
  dplyr::slice(sample(nrow(.), 10, replace = FALSE))

metaboliteList <- fobi_subset %>%
  pull(FOBI)

## ----warning = FALSE, eval = FALSE--------------------------------------------
# fobitools::ora(metaboliteList = metaboliteList,
#                metaboliteUniverse = metaboliteUniverse,
#                subOntology = "food",
#                pvalCutoff = 0.01)

## ----warning = FALSE, message = FALSE, comment = FALSE, echo = FALSE----------
res_ora <- fobitools::ora(metaboliteList = metaboliteList, 
                          metaboliteUniverse = metaboliteUniverse, 
                          subOntology = "food", 
                          pvalCutoff = 0.01)

## ----warning = FALSE, message = FALSE, comment = FALSE, echo = FALSE----------
kbl(res_ora, 
    row.names = FALSE,
    booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))

## ----warning = FALSE, message = FALSE, comment = FALSE, fig.align = "center", fig.height = 8, fig.width = 10----
terms <- fobi_subset %>%
  pull(id_code)

# create the associated graph
fobitools::fobi_graph(terms = terms, 
                      get = "anc",
                      labels = TRUE,
                      legend = TRUE)

## -----------------------------------------------------------------------------
sessionInfo()

---
title: "Use case: LC-MS Based Approaches to Investigate Metabolomic Differences in the Urine of Young Women after Drinking Cranberry Juice or Apple Juice"
author: 
- name: Pol Castellano-Escuder
  affiliation: Duke University
  email: polcaes@gmail.com
date: "`r BiocStyle::doc_date()`"
output: 
    BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Use case ST000291}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
  %\VignetteDepends{tidyverse, rvest, ggrepel, kableExtra, POMA, metabolomicsWorkbenchR, SummarizedExperiment}
bibliography: ["fobitools.bib"]
biblio-style: apalike
link-citations: true
---

**Compiled date**: `r Sys.Date()`

**Last edited**: 2024-10-17

**License**: `r packageDescription("fobitools")[["License"]]`

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Installation

Run the following code to install the Bioconductor version of the package.        

```{r, eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("fobitools")
```

# Load packages 

```{r, warning = FALSE, message = FALSE, comment = FALSE}
library(fobitools)
```

We will also need some additional [CRAN](https://cran.r-project.org) and [Bioconductor](https://bioconductor.org) packages for performing tasks such as statistical analysis and web scraping.   

```{r, warning = FALSE, message = FALSE, comment = FALSE}
# CRAN
library(tidyverse)
library(rvest)
library(ggrepel)
library(kableExtra)

# Bioconductor
library(POMA)
library(metabolomicsWorkbenchR)
library(SummarizedExperiment)
```

# Download the data from Metabolomics Workbench

The Metabolomics Workbench, available at [www.metabolomicsworkbench.org](www.metabolomicsworkbench.org), is a public repository for metabolomics metadata and experimental data spanning various species and experimental platforms, metabolite standards, metabolite structures, protocols, tutorials, and training material and other educational resources. It provides a computational platform to integrate, analyze, track, deposit and disseminate large volumes of heterogeneous data from a wide variety of metabolomics studies including mass spectrometry (MS) and nuclear magnetic resonance spectrometry (NMR) data spanning over 20 different species covering all the major taxonomic categories including humans and other mammals, plants, insects, invertebrates and microorganisms [@sud2016metabolomics].    

The `metabolomicsWorkbenchR` Bioconductor package allows us to obtain data from the Metabolomics Workbench repository. In this vignette we will use the sample data set [ST000291](https://www.metabolomicsworkbench.org/data/DRCCMetadata.php?Mode=Study&StudyID=ST000291). 

## Sumary of the study (ST000291)

Eighteen healthy female college students between 21-29 years old with a normal BMI of 18.5-25 were recruited. Each subject was provided with a list of foods that contained significant amount of procyanidins, such as **cranberries, apples, grapes, blueberries, chocolate and plums**. They were advised to avoid these foods during the 1-6th day and the rest of the study. On the morning of the 7th day, a first-morning baseline urine sample and blood sample were collected from all human subjects after overnight fasting. **Participants were then randomly allocated into two groups (n=9) to consume cranberry juice or apple juice**. Six bottles (250 ml/bottle) of juice were given to participants to drink in the morning and evening of the 7th, 8th, and 9th day. On the morning of 10th day, all subjects returned to the clinical unit to provide a first-morning urine sample after overnight fasting. The blood sample was also collected from participants 30 min later after they drank another bottle of juice in the morning. After two-weeks of wash out period, participants switched to the alternative regimen and repeated the protocol. One human subject was dropped off this study because she missed part of her appointments. Another two human subjects were removed from urine metabolomics analyses because they failed to provide required urine samples after juice drinking.The present study aimed to investigate overall metabolic changes caused by procyanidins concentrates from cranberries and apples using a global LCMS based metabolomics approach. All plasma and urine samples were stored at -80ºC until analysis.     

## Download data

This study is composed of two complementary MS analyses, the positive mode (AN000464) and the negative mode (AN000465). Let's download them both!   

```{r, warning = FALSE, message = FALSE, comment = FALSE}
data_negative_mode <- do_query(
  context = "study",
  input_item = "analysis_id",
  input_value = "AN000465",
  output_item = "SummarizedExperiment")

data_positive_mode <- do_query(
  context = "study",
  input_item = "analysis_id",
  input_value = "AN000464",
  output_item = "SummarizedExperiment")
```

## Scraping metabolite names and identifiers with `rvest`

In many metabolomics studies, the reproducibility of analyses is severely affected by the poor interoperability of metabolite names and their identifiers. For this reason it is important to develop tools that facilitate the process of converting one type of identifier to another. In order to use the `fobitools` package, we need some generic identifier (such as PubChem, KEGG or HMDB) that allows us to obtain the corresponding FOBI identifier for each metabolite. The Metabolomics Workbench repository provides us with this information for many of the metabolites quantified in study [ST000291](https://www.metabolomicsworkbench.org/data/show_metabolites_by_study.php?STUDY_ID=ST000291&SEARCH_TYPE=KNOWN&STUDY_TYPE=MS&RESULT_TYPE=1) (Figure \@ref(fig:metabolitenames)). In order to easily obtain this information, we will perform a web scraping operation using the `rvest` package.

```{r metabolitenames, message = FALSE, warning = FALSE, comment = FALSE, echo = FALSE, fig.align = "center", out.width = "100%", fig.cap = 'Metabolite identifiers of the ST000291 Metabolomics Workbench study.'}
knitr::include_graphics("figure/ST000291_names.png")
```

Below we obtain the PubChem and KEGG identifiers of the metabolites analyzed in the positive and negative mode directly from the Metabolomics Workbench website. We will then remove those duplicate identifiers.    

```{r, warning = FALSE, message = FALSE, comment = FALSE}
metaboliteNamesURL <- "https://www.metabolomicsworkbench.org/data/show_metabolites_by_study.php?STUDY_ID=ST000291&SEARCH_TYPE=KNOWN&STUDY_TYPE=MS&RESULT_TYPE=1"
metaboliteNames <- metaboliteNamesURL %>% 
  read_html() %>% 
  html_nodes(".datatable")

metaboliteNames_negative <- metaboliteNames %>%
  .[[1]] %>%
  html_table() %>%
  dplyr::select(`Metabolite Name`, PubChemCompound_ID, `Kegg Id`)

metaboliteNames_positive <- metaboliteNames %>%
  .[[2]] %>%
  html_table() %>%
  dplyr::select(`Metabolite Name`, PubChemCompound_ID, `Kegg Id`)

metaboliteNames <- bind_rows(metaboliteNames_negative, metaboliteNames_positive) %>%
  dplyr::rename(names = 1, PubChem = 2, KEGG = 3) %>%
  mutate(KEGG = ifelse(KEGG == "-", "UNKNOWN", KEGG),
         PubChem = ifelse(PubChem == "-", "UNKNOWN", PubChem)) %>%
  filter(!duplicated(PubChem))
```

# Prepare features and metadata

Now we have to prepare the metadata and features in order to proceed with the statistical analysis. In this step we assign to each metabolite its PubChem identifier obtained in the previous step.

```{r, warning = FALSE, message = FALSE, comment = FALSE}
## negative mode features 
features_negative <- assay(data_negative_mode) %>%
  dplyr::slice(-n())
rownames(features_negative) <- rowData(data_negative_mode)$metabolite[1:(length(rowData(data_negative_mode)$metabolite)-1)]

## positive mode features
features_positive <- assay(data_positive_mode) %>%
  dplyr::slice(-n())
rownames(features_positive) <- rowData(data_positive_mode)$metabolite[1:(length(rowData(data_positive_mode)$metabolite)-1)]

## combine positive and negative mode and set PubChem IDs as feature names
features <- bind_rows(features_negative, features_positive) %>%
  tibble::rownames_to_column("names") %>%
  right_join(metaboliteNames, by = "names") %>%
  select(-names, -KEGG) %>%
  tibble::column_to_rownames("PubChem")

## metadata
pdata <- colData(data_negative_mode) %>% # or "data_positive_mode". They are equal
  as.data.frame() %>%
  tibble::rownames_to_column("ID") %>%
  mutate(Treatment = case_when(Treatment == "Baseline urine" ~ "Baseline",
                               Treatment == "Urine after drinking apple juice" ~ "Apple",
                               Treatment == "Urine after drinking cranberry juice" ~ "Cranberry"))
```

# Statistical analysis with `POMA`

`POMA` provides a structured, reproducible and easy-to-use workflow for the visualization, preprocessing, exploration, and statistical analysis of metabolomics and proteomics data. The main aim of this package is to enable a flexible data cleaning and statistical analysis processes in one comprehensible and user-friendly R package. `POMA` uses the standardized `SummarizedExperiment` data structures, to achieve the maximum flexibility and reproducibility and makes `POMA` compatible with other Bioconductor packages [@POMA].

## Create a `SummarizedExperiment` object

First, we create a `SummarizedExperiment` object that integrates both metadata and features in the same data structure.

```{r, warning = FALSE, message = FALSE, comment = FALSE}
data_sumexp <- PomaCreateObject(metadata = pdata, features = t(features))
```

## Preprocessing

Second, we perform the preprocessing step. This step includes the missing value imputation unsing the $k$-NN algorithm and log Pareto normalization (transformation and scaling). Once these steps are completed, we can proceed to the statistical analysis of these data.

```{r, warning = FALSE, message = FALSE, comment = FALSE}
data_preprocessed <- data_sumexp %>%
  PomaImpute(group_by = "Treatment") %>%
  PomaNorm()
```

## Limma model

We use a limma model [@limma] to identify those most significant metabolites between the "**Baseline urine**" and "**Urine after drinking cranberry juice**" groups. With this analysis we expect to find metabolites related to cranberry intake.   

```{r, warning = FALSE, message = FALSE, comment = FALSE}
limma_res <- data_preprocessed %>%
  PomaLimma(contrast = "Baseline-Cranberry", adjust = "fdr") %>%
  dplyr::rename(PubChemCID = feature) %>% 
  dplyr::mutate(PubChemCID = gsub("X", "", PubChemCID))

# show the first 10 features
limma_res %>%
  dplyr::slice(1L:10L) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))
```

# Convert PubChem IDs to FOBI IDs

Once we have the results of the statistical analysis and generic identifiers recognized in the FOBI ontology [@castellano2020fobi], we can proceed to perform one of the main functions provided by the `fobitools` package, the ID conversion. With the `fobitools::id_convert()` command, users can convert different IDs between FOBI, HMDB, KEGG, PubChem, InChIKey, InChICode, ChemSpider, and chemical names. We will then obtain the FOBI IDs from the PubChem IDs (obtained in the previous sections) and add them as a new column to the results of the limma model.

```{r, warning = FALSE, message = FALSE, comment = FALSE}
limma_FOBI_names <- limma_res %>%
  dplyr::pull("PubChemCID") %>%
  fobitools::id_convert()

# show the ID conversion results
limma_FOBI_names %>%
  head() %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))
```

```{r, warning = FALSE, message = FALSE, comment = FALSE}
limma_FOBI_names <- limma_FOBI_names %>%
  dplyr::right_join(limma_res, by = "PubChemCID") %>%
  dplyr::arrange(-dplyr::desc(pvalue))
```

# Enrichment analysis

Enrichment analysis denotes any method that benefits from biological pathway or network information to gain insight into a biological system [@creixell2015pathway]. In other words, these type of analyses integrate the existing biological knowledge (from different biological sources such as databases and ontologies) and the statistical results of _omics_ studies, obtaining a deeper understanding of biological systems.  

In most metabolomics studies, the output of statistical analysis is usually a list of features selected as statistically significant or statistically relevant according to a pre-defined statistical criteria. Enrichment analysis methods use these selected features to explore associated biologically relevant pathways, diseases, etc., depending on the nature of the input feature list (genes, metabolites, etc.) and the source used to extract the biological knowledge (GO, KEGG, **FOBI**, etc.).    

Here, we present a tool that uses the FOBI information to perform different types of enrichment analyses. Therefore, the presented methods allow researchers to move from lists of metabolites to chemical classes and food groups associated with those lists, and consequently, to the study design. 

Currently, the most popular used approaches for enrichment analysis are the over representation analysis (ORA) and the gene set enrichment analysis (GSEA), with its variants for other fields such as the metabolite set enrichment analysis (MSEA) [@xia2010msea].

## Over representation analysis (ORA)

ORA is one of the most used methods to perform enrichment analysis in metabolomics studies due to its simplicity and easy understanding. This method statistically evaluates the fraction of metabolites in a particular pathway found among the set of metabolites statistically selected. Thus, ORA is used to test if certain groups of metabolites are represented more than expected by chance given a feature list. 

However, ORA has a number of limitations. The most important one is the need of using a certain threshold or criteria to select the feature list. This means that metabolites do not meet the selection criteria must be discarded. The second big limitation of ORA is that this method assumes independence of sets and features. In ORA, is assumed that each feature is independent of the other features and each set is independent of the other sets.

Here, we perform an ORA with the `fobitools` package, where we will use as a universe all the metabolites of the study present in FOBI and as a list those metabolites with a raw p-value < 0.01 in the limma results table.

```{r, warning = FALSE, message = FALSE, comment = FALSE}
metaboliteList <- limma_FOBI_names$FOBI[limma_FOBI_names$pvalue < 0.01]
metaboliteUniverse <- limma_FOBI_names$FOBI

fobitools::ora(metaboliteList = metaboliteList,
               metaboliteUniverse = metaboliteUniverse,
               pvalCutoff = 0.5) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))
```

As we can see, due to the limitations of this methodology and the small number of metabolites that meet the set statistical criterion, the results do not show a clear and obvious relationship with the design of the study, as the food groups that appear in the ORA results do not correspond to those foods administered in the intervention.

## MSEA

Gene Set Enrichment Analysis (GSEA) methodology was proposed for the first time in 2005, with the aim of improving the interpretation of gene expression data. The main purpose of GSEA is to determine whether members of a gene set $S$ tend to occur toward the top (or bottom) of the gene list $L$, in which case the gene set is correlated with the phenotypic class distinction [@subramanian2005gene]. 

This type of analysis basically consists of three key steps [@subramanian2005gene]: 

The first step consists on the calculation of an enrichment score ($ES$). This value indicates the degree to which a set $S$ is overrepresented at the extremes (top or bottom) of the entire ranked gene list $L$. The $ES$ is calculated by walking down the list $L$, increasing a running-sum statistic when a gene is found in $S$ and decreasing it when a gene is not found in $S$. The magnitude of the increment depends on the correlation of the gene with the phenotype. The $ES$ is the maximum deviation from zero encountered in the random walk. 

The second step is the estimation of significance level of $ES$. The statistical significance (nominal p-value) of the $ES$ is estimated by using an empirical phenotype-based permutation test that preserves the complex correlation structure of the gene expression data. The phenotype labels ($L$) are permuted and the $ES$ of the $S$ is recomputed for the permuted data, which generates a null distribution for the $ES$. The empirical, nominal p-value of the observed $ES$ is then calculated relative to this null distribution. The permutation of class labels (groups) preserves gene-gene correlations and, thus, provides a more biologically reasonable assessment of significance than would be obtained by permuting genes.

Finally, the third step consist on the adjustment for multiple hypothesis testing. When an entire database of gene sets is evaluated, the estimated significance level is adjusted for multiple hypothesis testing. First, the $ES$ is normalized for each gene set to account for the size of the set, yielding a normalized enrichment score (NES). Then, the proportion of false positives is controlled by calculating the FDR corresponding to each NES. 

In 2010, a modification of the GSEA methodology was presented for metabolomics studies. This method was called Metabolite Set Enrichment Analysis (MSEA) and its main aim was to help researchers identify and interpret patterns of human and mammalian metabolite concentration changes in a biologically meaningful context [@xia2010msea]. MSEA is currently widely used in the metabolomics community and it is implemented and freely available at the known [MetaboAnalyst](https://www.metaboanalyst.ca) web-based tool [@xia2010msea].

As can be seen, GSEA approach is more complex than the ORA methodology, both in terms of methodological aspects and understanding of the method.

The `fobitools` package provides a function to perform MSEA using the FOBI information. This function requires a ranked list. Here, we will use the metabolites obtained in the limma model ranked by raw p-values.  

```{r, warning = FALSE, message = FALSE, comment = FALSE}
limma_FOBI_msea <- limma_FOBI_names %>%
  dplyr::select(FOBI, pvalue) %>%
  dplyr::filter(!is.na(FOBI)) %>%
  dplyr::arrange(-dplyr::desc(abs(pvalue)))

FOBI_msea <- as.vector(limma_FOBI_msea$pvalue)
names(FOBI_msea) <- limma_FOBI_msea$FOBI

msea_res <- fobitools::msea(FOBI_msea, pvalCutoff = 0.06)

msea_res %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))
```

As we can see, the enrichment analysis with the MSEA method seems to be much more accurate than the ORA method, since the two classes that head the results table ("_grape (whole, raw)_" and "_grapefruit (whole, raw)_") are clearly within the FOBI food group (set) "_plant fruit food product_", which is aligned with the study intervention, cranberry juice intake.

```{r, warning = FALSE, message = FALSE, comment = FALSE}
fobi_graph(terms = c("FOODON:03301123", "FOODON:03301702"), 
           get = "anc", 
           labels = TRUE, 
           labelsize = 6)
```

### MSEA plot with `ggplot2`

```{r, warning = FALSE, message = FALSE, comment = FALSE, fig.width = 12, fig.height = 8}
ggplot(msea_res, aes(x = -log10(pval), y = NES, color = NES, size = classSize, label = className)) +
  xlab("-log10(P-value)") +
  ylab("NES (Normalized Enrichment Score)") +
  geom_point() +
  ggrepel::geom_label_repel(color = "black", size = 7) +
  theme_bw() +
  theme(legend.position = "top",
        text = element_text(size = 22)) +
  scale_color_viridis_c() +
  scale_size(guide = "none")
```

### Network of metabolites found in MSEA

```{r, warning = FALSE, message = FALSE, comment = FALSE, fig.width = 12, fig.height = 10}
FOBI_terms <- msea_res %>% 
  unnest(cols = leadingEdge)

fobitools::fobi %>%
  filter(FOBI %in% FOBI_terms$leadingEdge) %>%
  pull(id_code) %>%
  fobi_graph(get = "anc", 
             labels = TRUE, 
             legend = TRUE, 
             labelsize = 6, 
             legendSize = 20)
```

# Limitations

The FOBI ontology is currently in its first release version, so it does not yet include information on many metabolites and food relationships. All future efforts will be directed at expanding this ontology, leading to a significant increase in the number of metabolites and metabolite-food relationships. The `fobitools` package provides the methodology for easy use of the FOBI ontology regardless of the amount of information it contains. Therefore, future FOBI improvements will also have a direct impact on the `fobitools` package, increasing its utility and allowing to perform, among others, more accurate, complete and robust enrichment analyses.

# Session Information

```{r}
sessionInfo()
```

# References

---
title: "Simple food over representation analysis (ORA)"
author: 
- name: Pol Castellano-Escuder
  affiliation: Duke University
  email: polcaes@gmail.com
date: "`r BiocStyle::doc_date()`"
output: 
    BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Simple food ORA}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
bibliography: ["fobitools.bib"]
biblio-style: apalike
link-citations: true
---

**Compiled date**: `r Sys.Date()`

**Last edited**: 2022-01-12

**License**: `r packageDescription("fobitools")[["License"]]`

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Installation

Run the following code to install the Bioconductor version of the package.        

```{r, eval = FALSE}
# install.packages("BiocManager")
BiocManager::install("fobitools")
```

# Load `fobitools` 

```{r, warning = FALSE, message = FALSE, comment = FALSE}
library(fobitools)
```

You can also load some additional packages that will be very useful in this vignette.   

```{r, warning = FALSE, message = FALSE, comment = FALSE}
library(dplyr)
library(kableExtra)
```

# `metaboliteUniverse` and `metaboliteList`

In microarrays, for example, we can study almost all the genes of an organism in our sample, so it makes sense to perform an over representation analysis (ORA) considering all the genes present in Gene Ontology (GO). Since most of the GO pathways would be represented by some gene in the microarray.      

This is different in nutrimetabolomics. Targeted nutrimetabolomics studies sets of about 200-500 diet-related metabolites, so it would not make sense to use all known metabolites (for example in HMDB or CHEBI) in an ORA, as most of them would not have been quantified in the study.     

In nutrimetabolomic studies it may be interesting to study enriched or over represented foods/food groups by the metabolites resulting from the study statistical analysis, rather than the enriched metabolic pathways, as would make more sense in genomics or other metabolomics studies.     

The [Food-Biomarker Ontology (FOBI)](https://academic.oup.com/database/article/doi/10.1093/databa/baaa033/5857401) provides a biological knowledge for conducting these enrichment analyses in nutrimetabolomic studies, as FOBI provides the relationships between several foods and their associated dietary metabolites [@castellano2020fobi].             

Accordingly, to perform an ORA with the `fobitools` package, it is necessary to provide a metabolite universe (all metabolites included in the statistical analysis) and a list of selected metabolites (selected metabolites according to a statistical criterion).      

Here is an example:       

```{r, warning = FALSE, message = FALSE, comment = FALSE}
# select 300 random metabolites from FOBI
idx_universe <- sample(nrow(fobitools::idmap), 300, replace = FALSE)
metaboliteUniverse <- fobitools::idmap %>%
  dplyr::slice(idx_universe) %>%
  pull(FOBI)

# select 10 random metabolites from metaboliteUniverse that are associated with 'Red meat' (FOBI:0193), 
# 'Lean meat' (FOBI:0185) , 'egg food product' (FOODON:00001274), 
# or 'grape (whole, raw)' (FOODON:03301702)
fobi_subset <- fobitools::fobi %>% # equivalent to `parse_fobi()`
  filter(FOBI %in% metaboliteUniverse) %>%
  filter(id_BiomarkerOf %in% c("FOBI:0193", "FOBI:0185", "FOODON:00001274", "FOODON:03301702")) %>%
  dplyr::slice(sample(nrow(.), 10, replace = FALSE))

metaboliteList <- fobi_subset %>%
  pull(FOBI)
```

```{r, warning = FALSE, eval = FALSE}
fobitools::ora(metaboliteList = metaboliteList, 
               metaboliteUniverse = metaboliteUniverse, 
               subOntology = "food", 
               pvalCutoff = 0.01)
```

```{r, warning = FALSE, message = FALSE, comment = FALSE, echo = FALSE}
res_ora <- fobitools::ora(metaboliteList = metaboliteList, 
                          metaboliteUniverse = metaboliteUniverse, 
                          subOntology = "food", 
                          pvalCutoff = 0.01)
```

```{r, warning = FALSE, message = FALSE, comment = FALSE, echo = FALSE}
kbl(res_ora, 
    row.names = FALSE,
    booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))
```

# Network visualization of `metaboliteList` terms

Then, with the `fobi_graph` function we can visualize the `metaboliteList` terms with their corresponding FOBI relationships.           

```{r, warning = FALSE, message = FALSE, comment = FALSE, fig.align = "center", fig.height = 8, fig.width = 10}
terms <- fobi_subset %>%
  pull(id_code)

# create the associated graph
fobitools::fobi_graph(terms = terms, 
                      get = "anc",
                      labels = TRUE,
                      legend = TRUE)
```

# Session Information

```{r}
sessionInfo()
```

# References

---
title: "Dietary text annotation"
author: 
- name: Pol Castellano-Escuder
  affiliation: Duke University
  email: polcaes@gmail.com
date: "`r BiocStyle::doc_date()`"
output: 
    BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Dietary text annotation}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
  %\VignetteDepends{tidyverse, kableExtra}
bibliography: ["fobitools.bib"]
biblio-style: apalike
link-citations: true
---

**Compiled date**: `r Sys.Date()`

**Last edited**: 2022-01-12

**License**: `r packageDescription("fobitools")[["License"]]`

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Installation

Run the following code to install the Bioconductor version of the package.        

```{r, eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("fobitools")
```

# Load packages 

```{r, warning = FALSE, message = FALSE, comment = FALSE}
library(fobitools)
```

We will also need some additional [CRAN](https://cran.r-project.org) packages that will be very useful in this vignette.

```{r, warning = FALSE, message = FALSE, comment = FALSE}
library(tidyverse)
library(kableExtra)
```

# Load food items from a food frequency questionnaire (FFQ) sample data 

In nutritional studies, dietary data are usually collected by using different questionnaires such as FFQs (food frequency questionnaires) or 24h-DRs (24 hours dietary recall). Commonly, the text collected in these questionnaires require a manual preprocessing step before being analyzed.        

This is an example of how an FFQ could look like in a common nutritional study.     

```{r, warning = FALSE, message = FALSE, comment = FALSE}
load("data/sample_ffq.rda")

sample_ffq %>%
  dplyr::slice(1L:10L) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))
```

# Automatic dietary text anotation

The `fobitools::annotate_foods()` function allows the automatic annotation of free nutritional text using the FOBI ontology [@castellano2020fobi]. This function provides users with a table of food IDs, food names, FOBI IDs and FOBI names of the FOBI terms that match the input text. The input should be structured as a two column data frame, indicating the food IDs (first column) and food names (second column). Note that food names can be provided both as words and complex strings.            

This function includes a text mining algorithm composed of 5 sequential layers. In this process, singulars and plurals are analyzed, irrelevant words are removed, each string of the text input is tokenized and each word is analyzed independently, and the semantic similarity between input text and FOBI items is computed. Finally, this function also shows the percentage of the annotated input text.     

```{r, warning = FALSE}
annotated_text <- fobitools::annotate_foods(sample_ffq)

annotated_text$annotated %>%
  dplyr::slice(1L:10L) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))
```

## The similarity argument

Additionally, the _similarity_ argument indicates the semantic similarity cutoff used at the last layer of the text mining pipeline. It is a numeric value between 1 (exact match) and 0 (very poor match). Users can modify this value to obtain more or less accurated annotations. Authors do not recommend values below 0.85 (default).    

```{r, warning = FALSE}
annotated_text_95 <- fobitools::annotate_foods(sample_ffq, similarity = 0.95)

annotated_text_95$annotated %>%
  dplyr::slice(1L:10L) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))
```

See that by increasing the similarity value from 0.85 (default value) to 0.95 (a more accurate annotation), the percentage of annotated terms decreases from 89.57% to 86.5%. Let's check those food items annotated with `similarity = 0.85` but not with `similarity = 0.95`.     

```{r, warning = FALSE}
annotated_text$annotated %>%
  filter(!FOOD_ID %in% annotated_text_95$annotated$FOOD_ID) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))
```

### Network visualization of the annotated terms

Then, with the `fobitools::fobi_graph()` function we can visualize the annotated food terms with their corresponding FOBI relationships.          

```{r, warning = FALSE, message = FALSE, comment = FALSE, fig.width = 12, fig.height = 10}
terms <- annotated_text$annotated %>%
  pull(FOBI_ID)

fobitools::fobi_graph(terms = terms,
                      get = NULL,
                      layout = "lgl",
                      labels = TRUE,
                      legend = TRUE,
                      labelsize = 6,
                      legendSize = 20)
```

## How do I know which compounds are associated with my study food items?

Most likely we may be interested in knowing the food-related compounds in our study. Well, if so, once the foods are annotated we can obtain the metabolites associated with the annotated foods as follows:    

```{r, warning = FALSE}
inverse_rel <- fobitools::fobi %>%
  filter(id_BiomarkerOf %in% annotated_text$annotated$FOBI_ID) %>%
  dplyr::select(id_code, name, id_BiomarkerOf, FOBI) %>%
  dplyr::rename(METABOLITE_ID = 1, METABOLITE_NAME = 2, FOBI_ID = 3, METABOLITE_FOBI_ID = 4)

annotated_foods_and_metabolites <- left_join(annotated_text$annotated, inverse_rel, by = "FOBI_ID")

annotated_foods_and_metabolites %>%
  filter(!is.na(METABOLITE_ID)) %>%
  dplyr::slice(1L:10L) %>%
  kbl(row.names = FALSE, booktabs = TRUE) %>%
  kable_styling(latex_options = c("striped"))
```

# Limitations

The FOBI ontology is currently in its first release version, so it does not yet include information on many metabolites, foods and food relationships. All future efforts will be directed at expanding this ontology, leading to a significant increase in the number of metabolites, foods (from FoodOn ontology [@dooley2018foodon]) and metabolite-food relationships. The `fobitools` package provides the methodology for easy use of the FOBI ontology regardless of the amount of information it contains. Therefore, future FOBI improvements will also have a direct impact on the `fobitools` package, increasing its utility and allowing to perform, among others, more accurate, complete and robust dietary text annotations.        

# Session Information

```{r}
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ora.R
\name{ora}
\alias{ora}
\title{Classical Over Representation Analysis with FOBI}
\usage{
ora(
  metaboliteList,
  metaboliteUniverse,
  subOntology = "food",
  pvalCutoff = 0.01,
  fobi = fobitools::fobi
)
}
\arguments{
\item{metaboliteList}{A vector of FOBI metabolite identifiers that define the selected list of metabolites.}

\item{metaboliteUniverse}{A vector of FOBI metabolite identifiers that define the universe of possible metabolites (all metabolites analyzed in the study).}

\item{subOntology}{A character string specifying one of the two FOBI sub-ontologies: "food", or "biomarker".}

\item{pvalCutoff}{A numeric value indicating a p-value cutoff for raw p-values generated by hypergeometric test.}

\item{fobi}{FOBI table obtained with `parse_fobi()`. If this value is set to NULL, the last version of FOBI will be downloaded from GitHub.}
}
\value{
A tibble with ORA results.
}
\description{
This function performs a traditional over representation analysis based on hypergeometric test: classes are treated as sets of individual metabolites and all metabolites are treated as equally informative. This function uses Food-Biomarker Ontology knowledge as biological information.
}
\examples{

metaboliteUniverse <- c(fobitools::idmap$FOBI[1:200], fobitools::idmap$FOBI[400:450])
metaboliteList <- c(fobitools::idmap$FOBI[1:50], fobitools::idmap$FOBI[70:80])

# Food enrichment analysis
fobitools::ora(metaboliteList = metaboliteList, 
               metaboliteUniverse = metaboliteUniverse, 
               pvalCutoff = 1)

# Chemical class enrichment analysis
fobitools::ora(metaboliteList = metaboliteList, 
               metaboliteUniverse = metaboliteUniverse, 
               subOntology = "biomarker", 
               pvalCutoff = 1)

}
\references{
G. Korotkevich, V. Sukhov, A. Sergushichev. Fast gene set enrichment analysis. bioRxiv (2019), doi:10.1101/060012

Pol Castellano-Escuder, Raúl González-Domínguez, David S Wishart, Cristina Andrés-Lacueva, Alex Sánchez-Pla, FOBI: an ontology to represent food intake data and associate it with metabolomic data, Database, Volume 2020, 2020, baaa033, https://doi.org/10.1093/databa/baaa033.
}
\author{
Pol Castellano-Escuder
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{idmap}
\alias{idmap}
\title{FOBI Identifier Map File - Jul 18, 2021}
\format{
A tibble: 590 FOBI metabolites with 8 different IDs.
\describe{
  \item{metaboliteNames}{Raw metabolite names.}
  \item{FOBI}{FOBI ID.}
  \item{HMDB}{HMDB ID.}
  \item{KEGG}{KEGG ID.}
  \item{PubChemCID}{PubChemCID ID.}
  \item{InChIKey}{InChIKey ID.}
  \item{InChICode}{InChICode ID.}
  \item{ChemSpider}{ChemSpider ID.}
}
}
\source{
\url{https://github.com/pcastellanoescuder/FoodBiomarkerOntology}
}
\usage{
idmap
}
\description{
Identifier mappings for FOBI metabolites
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/msea.R
\name{msea}
\alias{msea}
\title{Performs a preranked metabolite set enrichment analysis (MSEA)}
\usage{
msea(
  metaboliteRanks,
  subOntology = "food",
  pvalCutoff = 0.01,
  fobi = fobitools::fobi
)
}
\arguments{
\item{metaboliteRanks}{A named vector of FOBI metabolite identifiers with their metabolite-level stats.}

\item{subOntology}{A character string specifying one of the two FOBI sub-ontologies: "food", or "biomarker".}

\item{pvalCutoff}{A numeric value indicating a p-value cutoff for raw p-values generated by MSEA.}

\item{fobi}{FOBI table obtained with `parse_fobi()`. If this value is set to NULL, the last version of FOBI will be downloaded from GitHub.}
}
\value{
A tibble with MSEA results.
}
\description{
This function performs a MSEA based on the adaptive multilevel splitting Monte Carlo approach.
}
\examples{

metabolites <- c(fobitools::idmap$FOBI[1:49], fobitools::idmap$FOBI[70:80])
random_pvals <- c(runif(n = length(metabolites)*0.3, min = 0.001, max = 0.05), runif(n = length(metabolites)*0.7, min = 0.05, max = 0.99))
names(random_pvals) <- metabolites
metaboliteRanks <- random_pvals[order(random_pvals)]

# Food enrichment analysis
fobitools::msea(metaboliteRanks = metaboliteRanks, 
                pvalCutoff = 1)

# Chemical class enrichment analysis
fobitools::msea(metaboliteRanks = metaboliteRanks, 
                subOntology = "biomarker", 
                pvalCutoff = 1)

}
\references{
G. Korotkevich, V. Sukhov, A. Sergushichev. Fast gene set enrichment analysis. bioRxiv (2019), doi:10.1101/060012

Pol Castellano-Escuder, Raúl González-Domínguez, David S Wishart, Cristina Andrés-Lacueva, Alex Sánchez-Pla, FOBI: an ontology to represent food intake data and associate it with metabolomic data, Database, Volume 2020, 2020, baaa033, https://doi.org/10.1093/databa/baaa033.
}
\author{
Pol Castellano-Escuder
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotate_foods.R
\name{annotate_foods}
\alias{annotate_foods}
\title{Text Mining Pipeline to Annotate Free Nutritional Text with FOBI}
\usage{
annotate_foods(foods, similarity = 0.85, reference = fobitools::foods)
}
\arguments{
\item{foods}{A two column data frame. First column must contain the ID (should be unique) and the second column must contain food items (it can be a word or a string).}

\item{similarity}{Numeric between 0 (low) and 1 (high). This value indicates the semantic similarity cutoff used at the last layer of the text mining pipeline. 1 = exact match; 0 = very poor match. Values below 0.85 are not recommended.}

\item{reference}{FOBI foods table obtained with `parse_fobi(terms = "FOBI:0001", get = "des")`. If this value is set to NULL, the last version of FOBI will be downloaded from GitHub.}
}
\value{
A list containing two tibble objects: annotated and unannotated food items.
}
\description{
This function provides a text mining pipeline to map nutritional free text to Food-Biomarker Ontology. This pipeline is composed of five sequential layers to map food items to FOBI with the maximum accuracy as possible.
}
\examples{

# Free text annotation in FOBI
free_text <- data.frame(id = c(101, 102, 103, 104),
                        text = c("Yesterday I ate eggs and bacon with a butter toast and black tea", 
                                 "Crisp bread and rice crackers with wholegrain", 
                                 "Beef and veal, one apple", "pizza without meat"))
annotate_foods(free_text)

}
\references{
Pol Castellano-Escuder, Raúl González-Domínguez, David S Wishart, Cristina Andrés-Lacueva, Alex Sánchez-Pla, FOBI: an ontology to represent food intake data and associate it with metabolomic data, Database, Volume 2020, 2020, baaa033, https://doi.org/10.1093/databa/baaa033.
}
\author{
Pol Castellano-Escuder
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{foods}
\alias{foods}
\title{FOBI Foods Table File - Feb 02, 2021}
\format{
A tibble: 568 FOBI food entities with their associated information.
\describe{
  \item{id_code}{FOBI entity ID.}
  \item{name}{FOBI entity name.}
  \item{is_a_code}{FOBI entity direct parent class ID.}
  \item{is_a_name}{FOBI entity direct parent class name.}
  \item{id_BiomarkerOf}{FOBI entity associated food ID (in terms of biomarker).}
  \item{BiomarkerOf}{FOBI entity associated food name (in terms of biomarker).}
  \item{ChemSpider}{ChemSpider ID.}
  \item{KEGG}{KEGG ID.}
  \item{PubChemCID}{PubChemCID ID.}
  \item{InChIKey}{InChIKey ID.}
  \item{InChICode}{InChICode ID.}
  \item{FOBI}{FOBI ID.}
  \item{alias}{FOBI entity alias name.}
  \item{HMDB}{HMDB ID.}
  \item{id_Contains}{FOBI entity associated food ID (in terms of a recipe).}
  \item{Contains}{FOBI entity associated food ID (in terms of a recipe).}
}
}
\source{
\url{https://github.com/pcastellanoescuder/FoodBiomarkerOntology}
}
\usage{
foods
}
\description{
FOBI foods table obtained with `parse_fobi(terms = "FOBI:0001", get = "des")`
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{fobi_terms}
\alias{fobi_terms}
\title{FOBI's `ontology_index` object - Jul 23, 2021}
\format{
An ontology_index object with 1201 terms.
\describe{
  \item{format-version:}{1.2}
  \item{data-version:}{fobi.owl}
  \item{ontology}{fobi}
  \item{Properties}{
  	id: character,
  	name: character,
  	parents: list,
  	children: list,
  	ancestors: list,
  	obsolete: logical}
  \item{Roots}{
  FOBI:0001 - Foods,
  FOBI:01501 - Biomarkers,
  FOBI:00422 - BiomarkerOf,
  FOBI:00423 - HasBiomarker,
  FOBI:00424 - Contains,
  FOBI:00425 - IsIngredientOf}
}
}
\source{
\url{https://github.com/pcastellanoescuder/FoodBiomarkerOntology}
}
\usage{
fobi_terms
}
\description{
FOBI terms obtained with `ontologyIndex::get_ontology()`
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/id_convert.R
\name{id_convert}
\alias{id_convert}
\title{Convert Metabolite Identifiers}
\usage{
id_convert(ids, to = "FOBI", fobi = fobitools::fobi)
}
\arguments{
\item{ids}{A vector with metabolite IDs to convert. Input ID types can be FOBI, raw metabolite names (used in FOBI), HMDB, KEGG, PubChemCID, InChIKey, InChICode, ChemSpider, and a combination of them.}

\item{to}{Target ID type. If possible, metabolites will be converted to this ID type. Options are "FOBI" (default), "metaboliteNames", "HMDB", "KEGG", "PubChemCID", "InChIKey", "InChICode", and "ChemSpider".}

\item{fobi}{FOBI table obtained with `parse_fobi()`. If this value is set to NULL, the last version of FOBI will be downloaded from GitHub.}
}
\value{
A tibble with input IDs and converted IDs.
}
\description{
This function can convert metabolite identifiers to other available IDs in FOBI. Input vector can be a combination of different IDs.
}
\examples{

ids <- c(fobitools::idmap$HMDB[1:10], 
         fobitools::idmap$KEGG[11:23], 
         fobitools::idmap$InChIKey[100:150])
fobitools::id_convert(ids, to = "FOBI")

}
\references{
Pol Castellano-Escuder, Raúl González-Domínguez, David S Wishart, Cristina Andrés-Lacueva, Alex Sánchez-Pla, FOBI: an ontology to represent food intake data and associate it with metabolomic data, Database, Volume 2020, 2020, baaa033, https://doi.org/10.1093/databa/baaa033.
}
\author{
Pol Castellano-Escuder
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parse_fobi.R
\name{parse_fobi}
\alias{parse_fobi}
\title{Parse FOBI in a Readable Tabular Format}
\usage{
parse_fobi(terms = NULL, get = NULL)
}
\arguments{
\item{terms}{A character vector with FOBI term IDs. Default is NULL.}

\item{get}{A character string indicating desired relationships between provided terms. Options are 'anc' (for ancestors) and 'des' (for descendants). Default is NULL and only information of single input terms will be provided.}
}
\value{
A tibble with FOBI terms information.
}
\description{
This function allows users to download and parse the last version of the Food-Biomarker Ontology into a readable table format.
}
\examples{

# Download and parse whole FOBI
fobi <- parse_fobi()

# Download and parse 'apple' related terms
fobi_apple <- parse_fobi(terms = "FOODON:00002473")

# Download and parse 'apple' term ancestors
fobi_apple_anc <- parse_fobi(terms = "FOODON:00002473", get = "anc")

# Download and parse 'apple' and 'alpha-Chaconine' related terms
fobi_subset <- parse_fobi(terms = c("FOODON:00002473", "CHEBI:10219"))

}
\references{
Pol Castellano-Escuder, Raúl González-Domínguez, David S Wishart, Cristina Andrés-Lacueva, Alex Sánchez-Pla, FOBI: an ontology to represent food intake data and associate it with metabolomic data, Database, Volume 2020, 2020, baaa033, https://doi.org/10.1093/databa/baaa033.
}
\author{
Pol Castellano-Escuder
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fobi_graph.R
\name{fobi_graph}
\alias{fobi_graph}
\title{Generate FOBI Graphs}
\usage{
fobi_graph(
  terms = NULL,
  get = NULL,
  property = c("is_a", "BiomarkerOf", "Contains"),
  layout = "sugiyama",
  labels = FALSE,
  labelsize = 3,
  legend = FALSE,
  legendSize = 10,
  legendPos = "bottom",
  curved = FALSE,
  pointSize = 3,
  fobi = fobitools::fobi
)
}
\arguments{
\item{terms}{A character vector with FOBI term IDs.}

\item{get}{A character string indicating desired relationships between provided terms. Options are 'anc' (for ancestors) and 'des' (for descendants). Default is NULL and all information related with input terms will be provided.}

\item{property}{A character vector indicating which properties should be plotted. Options are 'is_a', 'BiomarkerOf', and 'Contains'. By default all of them are included.}

\item{layout}{A character string indicating the type of layout to create. Options are 'sugiyama' (default) and 'lgl'.}

\item{labels}{Logical indicating if node names should be plotted or not.}

\item{labelsize}{Numeric value indicating the size of labels.}

\item{legend}{Logical indicating if legend should be plotted or not.}

\item{legendSize}{Numeric value indicating the size of legend.}

\item{legendPos}{A character string indicating the legend position (if legend parameter is set to TRUE). Options are 'bottom' (default) and 'top'.}

\item{curved}{Logical indicating if the shape of the edges shape should be curved or not.}

\item{pointSize}{Numeric value indicating the size of graph points.}

\item{fobi}{FOBI table obtained with `parse_fobi()`. If this value is set to NULL, the last version of FOBI will be downloaded from GitHub.}
}
\value{
A ggraph object.
}
\description{
This function allows users to create networks based on FOBI relationships.
}
\examples{

terms <- c("CHEBI:16164","CHEBI:16243","FOODON:00001139","FOODON:00003274","FOODON:00003275")
fobi_graph(terms, get = "anc")

# Red meat related FOBI biomarkers
fobi_graph(terms = "FOBI:0193", 
           property = c("is_a", "BiomarkerOf"), 
           layout = "lgl", curved = TRUE) # set labels = TRUE to display node names

}
\references{
Pol Castellano-Escuder, Raúl González-Domínguez, David S Wishart, Cristina Andrés-Lacueva, Alex Sánchez-Pla, FOBI: an ontology to represent food intake data and associate it with metabolomic data, Database, Volume 2020, 2020, baaa033, https://doi.org/10.1093/databa/baaa033.
}
\author{
Pol Castellano-Escuder
}
